<?php

namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\SM\Service\IntegracaoFmService;

class IntegracaoFmController extends SMCrud {
    
    protected $integracaoService;
    
    public function __construct ($crudService, $environment, IntegracaoFmService $integracaoService) {
        parent::__construct($crudService, $environment);
        $this->integracaoService            = $integracaoService;
    }
    
    /**
     * @param Request\Row $request
     */
    public function integraLocalAtend(Request $request, Response $response) {
        try {
            $row = $request->getRow();
            $nrseqcontrato = $row["NRSEQCONTRATO"];

            $result = $this->integracaoService->integraLocalAtend($nrseqcontrato);

            $response->addDataSet(new DataSet("integraLocalAtend", array("resultado" => $result)));
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    /**
     * @param Request\Row $request
     */
    public function importarMedicaoFM(Request $request, Response $response) {
        try {
            $row = $request->getRow();
            $nrseqcontrato = $row["NRSEQCONTRATO"];
            $nrmedicaofatura = $row["NRMEDICAOFATURA"];

            $result = $this->integracaoService->importarMedicaoFM($nrseqcontrato, $nrmedicaofatura);

            $response->addDataSet(new DataSet("importarMedicaoFM", array("resultado" => $result)));
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}

?>