DROP TABLE TMP_REGISTRO_PRODUTO
/

CREATE GLOBAL TEMPORARY TABLE TMP_REGISTRO_PRODUTO
(CDTIPOREG     VARCHAR2(2) NOT NULL,
 CDARVPROD     VARCHAR2(20) NOT NULL,
 DTINICIAL     DATE,
 DTFINAL       DATE,
 CDCLASFISC    VARCHAR2(20),
 NMPRODUTO     VARCHAR2(50),
 SGUNIDADE     VARCHAR2(06),
 CDSITUTRIBPR  VARCHAR2(3),
 VRALIQIPI     FLOAT,
 VRALIQICMS    FLOAT,
 VRPERREDBCIT  FLOAT,
 VRBASESUBST   FLOAT,
 CONSTRAINT PK_TMP_REGISTRO_PRODUTO PRIMARY KEY(CDTIPOREG, CDARVPROD)) ON COMMIT PRESERVE ROWS
/

CREATE TABLE TMP_REGISTRO_PRODUTO
(CDTIPOREG     VARCHAR2(2) NOT NULL,
 CDARVPROD     VARCHAR2(20) NOT NULL,
 DTINICIAL     DATE,
 DTFINAL       DATE,
 CDCLASFISC    VARCHAR2(20),
 NMPRODUTO     VARCHAR2(50),
 SGUNIDADE     VARCHAR2(06),
 CDSITUTRIBPR  VARCHAR2(3),
 VRALIQIPI     FLOAT,
 VRALIQICMS    FLOAT,
 VRPERREDBCIT  FLOAT,
 VRBASESUBST   FLOAT,
 CONSTRAINT PK_TMP_REGISTRO_PRODUTO PRIMARY KEY(CDTIPOREG, CDARVPROD))
/


create or replace PROCEDURE ARQUIVO_VALIDAPR(
   P_REGISTRO    IN VARCHAR2,
   P_CDIMPOSTO   IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA   IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA  IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL   IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL     IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTPOSICAO   IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_CDPAIS      IN ESTADO.CDPAIS%TYPE,
   P_SGESTADO    IN ESTADO.SGESTADO%TYPE,
   P_VERSAO      IN NOTAFISCAL.IDSTATUS%TYPE,
   P_FINALIDADE  IN NOTAFISCAL.IDSTATUS%TYPE,
   P_NRSEQARQMAG IN ARQMAGNETICO.NRSEQARQMAG%TYPE)
AS
   V_CONTGERAL      NUMBER;
   V_CONTREG        NUMBER;
   V_CONTADOR       NUMBER;
   V_CONTREG54A     NUMBER;
   V_CONTREG54B     NUMBER;
   V_CONTREG54C     NUMBER;
   V_STTOTAL        VARCHAR2(160);
   V_TOTALGERAL     VARCHAR2(10);
   V_CDARVPROD      VARCHAR2(20);
   V_SEQUENCIAL     VARCHAR2(03);
   V_CDFILIAL       VARCHAR2(04);
   V_NRLANCTONF     VARCHAR2(10);
BEGIN

   FOR C_REGISTRO10 IN (SELECT SUBSTR(
                           '10'||
                           RPAD(SUBSTR(REPLACE(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST,'.',''),',',''),'-',''),'/',''),1,14),14,' ')||
                           RPAD(REPLACE(REPLACE(REPLACE(REPLACE(DECODE(SUBSTR(UPPER(IE.CDINSCESTA),1,5),'ISENT','ISENTO',IE.CDINSCESTA),'.',''),',',''),'-',''),'/',''),14,' ')||
                           RPAD(EP.NMRAZSOCEMPR,35,' ')||
                           RPAD(MU.NMMUNICIPIO,30,' ')||
                           RPAD(IE.SGESTADO,2,' ')||
                           LPAD(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(NVL(IE.NRTELEIEST,'0'),' ',''),')',''),'(',''),'-',''),'.',''),10,'0')||
                           TO_CHAR(TO_DATE(P_DTINICIAL),'yyyymmdd')||
                           TO_CHAR(TO_DATE(P_DTFINAL),'yyyymmdd')||
                           P_VERSAO ||'3'||P_FINALIDADE,1,126) AS DSARQMAG
                        FROM EMPRESA EP, INSCRESTAD IE, MUNICIPIO MU
                        WHERE EP.CDEMPRESA   = P_CDEMPRESA    AND
                              IE.CDEMPRESA   = EP.CDEMPRESA   AND
                              IE.CDINSCESTA  = P_CDINSCESTA   AND
                              IE.CDPAIS      = MU.CDPAIS(+)   AND
                              IE.SGESTADO    = MU.SGESTADO(+) AND
                              IE.CDMUNICIPIO = MU.CDMUNICIPIO(+)) LOOP
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('00'||LPAD(RTRIM('00'), 8, '0'), C_REGISTRO10.DSARQMAG, P_NRSEQARQMAG);
   END LOOP;
   FOR C_REGISTRO11 IN (SELECT SUBSTR(
                           '11'||
                           RPAD(IE.DSENDEIEST,34,' ')||
                           RPAD('00000s/n',27,' ')||
                           RPAD(IE.NMBAIRIEST,15,' ')||
                           LPAD(REPLACE(REPLACE(IE.NRCEPIEST,'.',''),'-',''),8,'0')||
                           RPAD(NVL(IE.NMREPRINSEST, ' '),28,' ')||
                           LPAD(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(NVL(IE.NRTELEIEST,'0'),' ',''),')',''),'(',''),'-',''),'.',''),12,'0')
                           ,1,126) AS DSARQMAG
                        FROM INSCRESTAD IE
                        WHERE IE.CDEMPRESA   = P_CDEMPRESA   AND
                              IE.CDINSCESTA  = P_CDINSCESTA) LOOP
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('01'||LPAD(RTRIM('00'), 8, '0'), C_REGISTRO11.DSARQMAG, P_NRSEQARQMAG);
   END LOOP;
   /* GERAO DO REGISTRO 50 */
   V_CONTGERAL := 2;
   V_CONTREG := 0;
   V_CONTADOR := 0;
   IF SUBSTR(P_REGISTRO,1,1) = 'S' THEN
      FOR C_REGISTRO50 IN (SELECT DATA, SUBSTR('50'        ||
                                               NRINSJUR    ||
                                               NRINSEST    ||
                                               DATA        ||
                                               SGESTADO    ||
                                               CDMODDOCFISC||
                                               SERIE       ||
                                               NRNOTAFISC  ||
                                               CDFISCOPERNF||
                                               IDENTRSAIDOP||
                                               VRCONTABILNF||
                                               VRBASECALCNF||
                                               VRIMPOSTONF ||
                                               VRISENTRIB  ||
                                               VROUTCRED   ||
                                               VRALIQNF    ||
                                               'N' ,1,126) AS DSARQMAG
                           FROM(SELECT '50',
                                       LPAD(NVL(DECODE(CL.IDTPIJURCLIE,'I','','O', '',CL.NRINSJURCLIE),'00000000000000'),14,'0') AS NRINSJUR,
                                       RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(CL.NRINSESTCLIE, ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO'),14,' ')AS NRINSEST,
                                       TO_CHAR(DECODE(NF.IDENTRSAIDOP,'E',NF.DTENTRSAID, NF.DTEMISSAO),'yyyymmdd') AS DATA,
                                       RPAD(NVL(EC.SGESTADO,' '),2,' ')AS SGESTADO,
                                       RPAD(NVL(NF.CDMODDOCFISC,'01'), 2, ' ') AS CDMODDOCFISC,
                                       RPAD(DECODE(TRIM(NVL(NF.CDSERIE,NF.CDSERIEENTR)),'-',' ','0',' ',REPLACE(NVL(NF.CDSERIE,NF.CDSERIEENTR), '-', '')),3,' ') AS SERIE,
                                       LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0') AS NRNOTAFISC,
                                       RPAD(NVL(NF.CDFISCOPERNF,'0'),4,' ') AS CDFISCOPERNF,
                                       DECODE(NF.IDENTRSAIDOP, 'E', 'T', 'P') AS IDENTRSAIDOP,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRCONTABILNF),'00000000000.00'),'.','')) AS VRCONTABILNF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRBASECALCNF),'00000000000.00'),'.','')) AS VRBASECALCNF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRIMPOSTONF) ,'00000000000.00'),'.','')) AS VRIMPOSTONF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRISENTRIB)  ,'00000000000.00'),'.','')) AS VRISENTRIB,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VROUTRCRED)  ,'00000000000.00'),'.','')) AS VROUTCRED,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRALIQNF)    ,'00.00'),'.','')) AS VRALIQNF,
                                       'N'
                                FROM CLIENTE CL, ENDECLIE EC, CLIENTE CA,
                                    (SELECT I.CDFILIAL, I.NRLANCTONF,N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDCLIENTE, N.DTENTRSAID,
                                            N.DTEMISSAO,
                                            DECODE(CDFISCALNF , '1', I.VRALIQNF, 0) AS VRALIQNF,
                                            I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                            SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                            SUM(I.VRBASECALCNF) AS VRBASECALCNF,
                                            SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                            SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0))   AS VROUTRCRED,
                                            SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0)) AS VRISENTRIB
                                     FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM
                                     WHERE M.CDEMPRESA       = P_CDEMPRESA                                  AND
                                           M.CDINSCESTA      = P_CDINSCESTA                                 AND
                                           M.DTINIPERIODO    = P_DTINICIAL                                  AND
                                           M.DTFIMPERIODO    = P_DTFINAL                                    AND
                                           M.CDIMPOSTO       = P_CDIMPOSTO                                  AND
                                           I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                               AND
                                           IM.CDIMPOSTONFE   = P_CDIMPOSTO                                  AND
                                           IM.CDIMPOSTO      = I.CDIMPOSTO                                  AND
                                           NVL(I.IDIMPOSTONF, '1') <> '3'                                   AND
                                           N.CDFILIAL        = I.CDFILIAL                                   AND
                                           N.NRLANCTONF      = I.NRLANCTONF                                 AND
                                           N.IDSTATUS IN ('A','E')                                          AND
                                           NVL(N.IDORIGDESTNF, DECODE(N.IDENTRSAIDOP, 'E', 'F', 'C')) = 'C' AND
                                           NVL(SUBSTR(I.CDFISCOPERNF,1,1),' ') <> '7'                       AND
                                           NVL(N.CDMODDOCFISC, '01') = MD.CDMODDOCFISC                      AND
                                           MD.CDTPREGFISC  = '50'                                           AND
                                           (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                     GROUP BY I.CDFILIAL, I.NRLANCTONF, N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR,
                                              N.CDCLIENTE, N.DTENTRSAID, N.DTEMISSAO, DECODE(CDFISCALNF , '1', I.VRALIQNF, 0), I.CDFISCOPERNF,
                                              N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF
                                WHERE CL.CDCLIENTE(+)    = NF.CDCLIENTE                 AND
                                      CA.CDCLIENTE       = NF.CDCLIENTE                 AND
                                      EC.CDCLIENTE(+)    = CA.CDCLIENTE                 AND
                                      EC.IDTPENDECLIE(+) = NVL(CA.IDENDEMISCLI,'P')     AND
                                      EC.CDPAIS          = NVL(P_CDPAIS,EC.CDPAIS)     AND
                                      (INSTR(NVL(P_SGESTADO, EC.SGESTADO), EC.SGESTADO) > 0)
                                UNION ALL
                                SELECT '50',
                                       '00000000000000' AS NRINSJUR,
                                       'ISENTO        ' AS NRINSEST,
                                       TO_CHAR(DECODE(NF.IDENTRSAIDOP,'E', NF.DTENTRSAID, NF.DTEMISSAO),'yyyymmdd') AS DATA,
                                       'EX' AS SGESTADO,
                                       RPAD(NVL(NF.CDMODDOCFISC,'01'), 2, ' ') AS CDMODDOCFISC,
                                       RPAD(DECODE(TRIM(NVL(NF.CDSERIE,NF.CDSERIEENTR)),'-',' ','0',' ',REPLACE(NVL(NF.CDSERIE,NF.CDSERIEENTR), '-', '')),3,' ') AS SERIE,
                                       LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0') AS NRNOTAFISC,
                                       RPAD(NVL(NF.CDFISCOPERNF,'0'),4,' ')AS CDFISCOPERNF,
                                       DECODE(NF.IDENTRSAIDOP, 'E', 'T', 'P') AS IDENTRSAIDOP,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRCONTABILNF),'00000000000.00'),'.','')) AS VRCONTABILNF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRBASECALCNF),'00000000000.00'),'.','')) AS VRBASECALCNF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRIMPOSTONF) ,'00000000000.00'),'.','')) AS VRIMPOSTONF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRISENTRIB)  ,'00000000000.00'),'.','')) AS VRISENTRIB,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VROUTRCRED)  ,'00000000000.00'),'.','')) AS VROUTCRED,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRALIQNF)    ,'00.00'),'.','')) AS VRALIQNF,
                                       'N'
                                FROM CLIENTE CL, ENDECLIE EC, CLIENTE CA,
                                    (SELECT I.CDFILIAL, I.NRLANCTONF,N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDCLIENTE, N.DTENTRSAID,
                                            N.DTEMISSAO, DECODE(CDFISCALNF , '1', I.VRALIQNF, 0) AS VRALIQNF,
                                            I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                            SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                            SUM(I.VRBASECALCNF) AS VRBASECALCNF,
                                            SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                            SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0))   AS VROUTRCRED,
                                            SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1', DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0)) AS VRISENTRIB
                                     FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM
                                     WHERE M.CDEMPRESA       = P_CDEMPRESA                                  AND
                                           M.CDINSCESTA      = P_CDINSCESTA                                 AND
                                           M.DTINIPERIODO    = P_DTINICIAL                                  AND
                                           M.DTFIMPERIODO    = P_DTFINAL                                    AND
                                           M.CDIMPOSTO       = P_CDIMPOSTO                                  AND
                                           I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                               AND
                                           IM.CDIMPOSTONFE   = P_CDIMPOSTO                                  AND
                                           IM.CDIMPOSTO      = I.CDIMPOSTO                                  AND
                                           NVL(I.IDIMPOSTONF, '1') <> '3'                                   AND
                                           N.CDFILIAL        = I.CDFILIAL                                   AND
                                           N.NRLANCTONF      = I.NRLANCTONF                                 AND
                                           N.IDSTATUS IN ('A','E')                                          AND
                                           NVL(N.IDORIGDESTNF, DECODE(N.IDENTRSAIDOP, 'E', 'F', 'C')) = 'C' AND
                                           SUBSTR(I.CDFISCOPERNF,1,1) = '7'                                 AND
                                           NVL(N.CDMODDOCFISC, '01')  = MD.CDMODDOCFISC                     AND
                                           MD.CDTPREGFISC  = '50'                                           AND
                                           (NVL(IDSISTEMA,'DFS') <> 'PAG' AND
                                            NVL(IDSISTEMA,'DFS') <> 'REC' AND
                                            NVL(IDSISTEMA,'DFS') <> 'CMP' AND
                                            NVL(IDSISTEMA,'DFS') <> 'SUP' AND
                                            NVL(IDSISTEMA,'DFS') <> 'FIS')
                                     GROUP BY I.CDFILIAL, I.NRLANCTONF, N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR,
                                              N.CDCLIENTE, N.DTENTRSAID, N.DTEMISSAO, DECODE(CDFISCALNF , '1', I.VRALIQNF, 0), I.CDFISCOPERNF,
                                              N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF
                                WHERE CL.CDCLIENTE(+)    = NF.CDCLIENTE             AND
                                      CA.CDCLIENTE       = NF.CDCLIENTE             AND
                                      EC.CDCLIENTE(+)    = CA.CDCLIENTE             AND
                                      EC.IDTPENDECLIE(+) = NVL(CA.IDENDEMISCLI,'P') AND
                                      EC.CDPAIS          = NVL(P_CDPAIS,EC.CDPAIS) AND
                                      (INSTR(NVL(P_SGESTADO, EC.SGESTADO),EC.SGESTADO) > 0)
                                UNION ALL
                                SELECT '50',
                                       LPAD(NVL(DECODE(FO.IDTPIJURFORN,'I','','O', '',FO.NRINSJURFORN),'00000000000000'),14,'0') AS NRINSJUR,
                                       RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(FO.NRINSESTFORN, ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO'),14,' ')AS NRINSEST,
                                       TO_CHAR(DECODE(NF.IDENTRSAIDOP, 'S', NF.DTEMISSAO, NF.DTENTRSAID),'yyyymmdd') AS DATA,
                                       RPAD(NVL(EF.SGESTADO,' '),2,' ') AS SGESTADO,
                                       RPAD(NVL(NF.CDMODDOCFISC,'01'), 2, ' ') AS CDMODDOCFISC,
                                       RPAD(DECODE(TRIM(NVL(NF.CDSERIEENTR,NF.CDSERIE)),'-',' ','0',' ',REPLACE(NVL(NF.CDSERIEENTR,NF.CDSERIE), '-', '')),3,' ') AS SERIE,
                                       LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0')AS NRNOTAFISC,
                                       RPAD(NVL(NF.CDFISCOPERNF,'0'),4,' ') AS CDFISCOPERNF,
                                       DECODE(NF.IDENTRSAIDOP, 'E', 'T', 'P') AS IDENTRSAIDOP,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRCONTABILNF),'00000000000.00'),'.','')) AS VRCONTABILNF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRBASECALCNF),'00000000000.00'),'.','')) AS VRBASECALCNF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRIMPOSTONF) ,'00000000000.00'),'.','')) AS VRIMPOSTONF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRISENTRIB)  ,'00000000000.00'),'.','')) AS VRISENTRIB,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VROUTRCRED)  ,'00000000000.00'),'.','')) AS VROUTCRED,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRALIQNF)    ,'00.00'),'.','')) AS VRALIQNF,
                                       'N'
                                FROM FORNECEDOR FO, ENDEFORN EF, FORNECEDOR FA,
                                    (SELECT I.CDFILIAL, I.NRLANCTONF,N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFORNECED,
                                            N.DTENTRSAID, N.DTEMISSAO, DECODE(CDFISCALNF , '1', I.VRALIQNF, 0) AS VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                            SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                            SUM(I.VRBASECALCNF) AS VRBASECALCNF,
                                            SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                            SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0))   AS VROUTRCRED,
                                            SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF, '1', DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0)) AS VRISENTRIB
                                     FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM
                                     WHERE M.CDEMPRESA       = P_CDEMPRESA                                  AND
                                           M.CDINSCESTA      = P_CDINSCESTA                                 AND
                                           M.DTINIPERIODO    = P_DTINICIAL                                  AND
                                           M.DTFIMPERIODO    = P_DTFINAL                                    AND
                                           M.CDIMPOSTO       = P_CDIMPOSTO                                  AND
                                           I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                               AND
                                           IM.CDIMPOSTONFE   = P_CDIMPOSTO                                  AND
                                           IM.CDIMPOSTO      = I.CDIMPOSTO                                  AND
                                           NVL(I.IDIMPOSTONF, '1') <> '3'                                   AND
                                           N.CDFILIAL        = I.CDFILIAL                                   AND
                                           N.NRLANCTONF      = I.NRLANCTONF                                 AND
                                           N.IDSTATUS IN ('A','E')                                          AND
                                           NVL(N.IDORIGDESTNF, DECODE(N.IDENTRSAIDOP, 'E', 'F', 'C')) = 'F' AND
                                           NVL(SUBSTR(I.CDFISCOPERNF,1,1),' ') <> '3'                       AND
                                           NVL(N.CDMODDOCFISC, '01')  = MD.CDMODDOCFISC                     AND
                                           MD.CDTPREGFISC  = '50'                                           AND
                                           (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                     GROUP BY I.CDFILIAL, I.NRLANCTONF, N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR,
                                              N.CDFORNECED, N.DTENTRSAID, N.DTEMISSAO, DECODE(CDFISCALNF , '1', I.VRALIQNF, 0), I.CDFISCOPERNF,
                                              N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF
                                WHERE FO.CDFORNECED(+)   = NF.CDFORNECED            AND
                                      FA.CDFORNECED      = NF.CDFORNECED            AND
                                      EF.CDFORNECED(+)   = FA.CDFORNECED            AND
                                      EF.IDTPENDEFORN(+) = NVL(FA.IDENDEMISFOR,'P') AND
                                      EF.CDPAIS          = NVL(P_CDPAIS,EF.CDPAIS) AND
                                      (INSTR(NVL(P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0)
                                UNION ALL
                                SELECT '50',
                                       '00000000000000' AS NRINSJUR,
                                       'ISENTO        ' AS NRINSEST,
                                       TO_CHAR(DECODE(NF.IDENTRSAIDOP, 'S', NF.DTEMISSAO, NF.DTENTRSAID),'yyyymmdd') AS DATA,
                                       'EX' AS SGESTADO,
                                       RPAD(NVL(NF.CDMODDOCFISC,'01'), 2, ' ') AS CDMODDOCFISC,
                                       RPAD(DECODE(TRIM(NVL(NF.CDSERIEENTR,NF.CDSERIE)),'-',' ','0',' ',REPLACE(NVL(NF.CDSERIEENTR,NF.CDSERIE), '-', '')),3,' ') AS SERIE,
                                       LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0')AS NRNOTAFISC,
                                       RPAD(NVL(NF.CDFISCOPERNF,'0'),4,' ') AS CDFISCOPERNF,
                                       DECODE(NF.IDENTRSAIDOP, 'E', 'T', 'P') AS IDENTRSAIDOP,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRCONTABILNF),'00000000000.00'),'.','')) AS VRCONTABILNF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRBASECALCNF),'00000000000.00'),'.','')) AS VRBASECALCNF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRIMPOSTONF) ,'00000000000.00'),'.','')) AS VRIMPOSTONF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRISENTRIB)  ,'00000000000.00'),'.','')) AS VRISENTRIB,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VROUTRCRED)  ,'00000000000.00'),'.','')) AS VROUTCRED,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRALIQNF)    ,'00.00'),'.','')) AS VRALIQNF,
                                       'N'
                                FROM FORNECEDOR FO, ENDEFORN EF, FORNECEDOR FA,
                                    (SELECT I.CDFILIAL, I.NRLANCTONF,N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFORNECED,
                                            N.DTENTRSAID, N.DTEMISSAO, DECODE(CDFISCALNF , '1', I.VRALIQNF, 0) AS VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                            SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                            SUM(I.VRBASECALCNF) AS VRBASECALCNF,
                                            SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                            SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0))   AS VROUTRCRED,
                                            SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF, '1', DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0)) AS VRISENTRIB
                                     FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM
                                     WHERE M.CDEMPRESA       = P_CDEMPRESA                                  AND
                                           M.CDINSCESTA      = P_CDINSCESTA                                 AND
                                           M.DTINIPERIODO    = P_DTINICIAL                                  AND
                                           M.DTFIMPERIODO    = P_DTFINAL                                    AND
                                           M.CDIMPOSTO       = P_CDIMPOSTO                                  AND
                                           I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                               AND
                                           IM.CDIMPOSTONFE   = P_CDIMPOSTO                                  AND
                                           IM.CDIMPOSTO      = I.CDIMPOSTO                                  AND
                                           NVL(I.IDIMPOSTONF, '1') <> '3'                                   AND
                                           N.CDFILIAL        = I.CDFILIAL                                   AND
                                           N.NRLANCTONF      = I.NRLANCTONF                                 AND
                                           NVL(N.IDORIGDESTNF, DECODE(N.IDENTRSAIDOP, 'E', 'F', 'C')) = 'F' AND
                                           N.IDSTATUS IN ('A','E')                                          AND
                                           SUBSTR(I.CDFISCOPERNF,1,1) = '3'                                 AND
                                           NVL(N.CDMODDOCFISC, '01')  = MD.CDMODDOCFISC                     AND
                                           MD.CDTPREGFISC  = '50'                                           AND
                                           (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                     GROUP BY I.CDFILIAL, I.NRLANCTONF, N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR,
                                              N.CDFORNECED, N.DTENTRSAID, N.DTEMISSAO, DECODE(CDFISCALNF , '1', I.VRALIQNF, 0), I.CDFISCOPERNF,
                                              N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF
                                WHERE FO.CDFORNECED(+)   = NF.CDFORNECED            AND
                                      FA.CDFORNECED      = NF.CDFORNECED            AND
                                      EF.CDFORNECED(+)   = FA.CDFORNECED            AND
                                      EF.IDTPENDEFORN(+) = NVL(FA.IDENDEMISFOR,'P') AND
                                      EF.CDPAIS          = NVL(P_CDPAIS,EF.CDPAIS) AND
                                      (INSTR( NVL(P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0)
                                UNION ALL
                                SELECT '50',
                                       RPAD(NVL(REPLACE(REPLACE(REPLACE(FI.NRINSJURFILI, '-', ''), '.', ''), '/', ''),'00000000000000'),14,' ') AS NRINSJUR,
                                       RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(DECODE(SUBSTR(UPPER(FI.CDINSCESTA),1,5),'ISENT','ISENTO',FI.CDINSCESTA), ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO'),14,' ') AS NRINSEST,
                                       TO_CHAR(NF.DTENTRSAID,'yyyymmdd') AS DATA,
                                       RPAD(NVL(DECODE(NVL(F.IDENDEMISFIL,'P'),'I',IE.SGESTADO,EF.SGESTADO),' '),2,' ') AS SGESTADO,
                                       RPAD(NVL(NF.CDMODDOCFISC,'01'), 2, ' ') AS CDMODDOCFISC,
                                       RPAD(DECODE(TRIM(NVL(NF.CDSERIE,NF.CDSERIEENTR)),'-',' ','0',' ',REPLACE(NVL(NF.CDSERIE,NF.CDSERIEENTR), '-', '')),3,' ') AS SERIE,
                                       LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0')AS NRNOTAFISC,
                                       RPAD(NVL(NF.CDFISCOPERNF,'0'),4,' ') AS CDFISCOPERNF,
                                       DECODE(NF.IDENTRSAIDOP, 'E', 'T', 'P') AS IDENTRSAIDOP,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRCONTABILNF),'00000000000.00'),'.','')) AS VRCONTABILNF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRBASECALCNF),'00000000000.00'),'.','')) AS VRBASECALCNF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRIMPOSTONF) ,'00000000000.00'),'.','')) AS VRIMPOSTONF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRISENTRIB)  ,'00000000000.00'),'.','')) AS VRISENTRIB,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VROUTRCRED)  ,'00000000000.00'),'.','')) AS VROUTCRED,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRALIQNF)    ,'00.00'),'.','')) AS VRALIQNF,
                                       'N'
                                FROM FILIAL FI, ENDEFILI EF, FILIAL F, INSCRESTAD IE,
                                    (SELECT I.CDFILIAL, I.NRLANCTONF,N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFILIEMIT, N.CDINSCESTA,
                                            N.DTENTRSAID, DECODE(CDFISCALNF , '1', I.VRALIQNF, 0) AS VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                            SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                            SUM(I.VRBASECALCNF) AS VRBASECALCNF,
                                            SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                            SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0))   AS VROUTRCRED,
                                            SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF, '1', DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0)) AS VRISENTRIB
                                     FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM
                                     WHERE M.CDEMPRESA       = P_CDEMPRESA                                  AND
                                           M.CDINSCESTA      = P_CDINSCESTA                                 AND
                                           M.DTINIPERIODO    = P_DTINICIAL                                  AND
                                           M.DTFIMPERIODO    = P_DTFINAL                                    AND
                                           M.CDIMPOSTO       = P_CDIMPOSTO                                  AND
                                           I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                               AND
                                           IM.CDIMPOSTONFE   = P_CDIMPOSTO                                  AND
                                           IM.CDIMPOSTO      = I.CDIMPOSTO                                  AND
                                           NVL(I.IDIMPOSTONF, '1') <> '3'                                   AND
                                           N.CDFILIAL        = I.CDFILIAL                                   AND
                                           N.NRLANCTONF      = I.NRLANCTONF                                 AND
                                           N.IDENTRSAIDOP    = 'E'                                          AND
                                           N.IDSTATUS IN ('A','E')                                          AND
                                           NVL(N.IDORIGDESTNF, DECODE(N.IDENTRSAIDOP, 'E', 'F', 'C')) = 'L' AND
                                           NVL(SUBSTR(I.CDFISCOPERNF,1,1),' ') <> '3'                       AND
                                           NVL(N.CDMODDOCFISC, '01') = MD.CDMODDOCFISC                      AND
                                           MD.CDTPREGFISC  = '50'                                           AND
                                           (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                     GROUP BY I.CDFILIAL, I.NRLANCTONF, N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFILIEMIT, N.CDINSCESTA,
                                              N.DTENTRSAID, DECODE(CDFISCALNF , '1', I.VRALIQNF, 0), I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF
                                WHERE FI.CDFILIAL(+)     = NF.CDFILIEMIT           AND
                                      F.CDFILIAL         = NF.CDFILIEMIT           AND
                                      EF.CDFILIAL(+)     = F.CDFILIAL              AND
                                      EF.IDTPENDEFILI(+) = NVL(F.IDENDEMISFIL,'P') AND
                                      IE.CDINSCESTA      = NF.CDINSCESTA           AND
                                      IE.CDEMPRESA       = P_CDEMPRESA             AND
                                      NVL(EF.CDPAIS,IE.CDPAIS) = NVL(P_CDPAIS,NVL(EF.CDPAIS,IE.CDPAIS)) AND
                                      (INSTR(NVL(P_SGESTADO, NVL(EF.SGESTADO,IE.SGESTADO)), NVL(EF.SGESTADO,IE.SGESTADO)) > 0)
                                UNION ALL
                                SELECT '50',
                                       RPAD(NVL(REPLACE(REPLACE(REPLACE(FI.NRINSJURFILI, '-', ''), '.', ''), '/', ''),'00000000000000'),14,' ')AS NRINSJUR,
                                       RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(DECODE(SUBSTR(UPPER(FI.CDINSCESTA),1,5),'ISENT','ISENTO',FI.CDINSCESTA), ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO'),14,' ') AS NRINSEST,
                                       TO_CHAR(NF.DTEMISSAO,'yyyymmdd') AS DATA,
                                       RPAD(NVL(DECODE(NVL(F.IDENDEMISFIL,'P'),'I',IE.SGESTADO,EF.SGESTADO),' '),2,' ') AS SGESTADO,
                                       RPAD(NVL(NF.CDMODDOCFISC,'01'), 2, ' ') AS CDMODDOCFISC,
                                       RPAD(DECODE(TRIM(NVL(NF.CDSERIE,NF.CDSERIEENTR)),'-',' ','0',' ',REPLACE(NVL(NF.CDSERIE,NF.CDSERIEENTR), '-', '')),3,' ')AS SERIE,
                                       LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0') AS NRNOTAFISC,
                                       RPAD(NVL(NF.CDFISCOPERNF,'0'),4,' ') AS CDFISCOPERNF,
                                       DECODE(NF.IDENTRSAIDOP, 'E', 'T', 'P') AS IDENTRSAIDOP,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRCONTABILNF),'00000000000.00'),'.','')) AS VRCONTABILNF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRBASECALCNF),'00000000000.00'),'.','')) AS VRBASECALCNF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRIMPOSTONF) ,'00000000000.00'),'.','')) AS VRIMPOSTONF,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRISENTRIB)  ,'00000000000.00'),'.','')) AS VRISENTRIB,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VROUTRCRED)  ,'00000000000.00'),'.','')) AS VROUTCRED,
                                       LTRIM(REPLACE(TO_CHAR(ABS(NF.VRALIQNF)    ,'00.00'),'.','')) AS VRALIQNF,
                                       'N'
                                FROM FILIAL FI, ENDEFILI EF, FILIAL F, INSCRESTAD IE,
                                    (SELECT I.CDFILIAL, I.NRLANCTONF,N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFILIRECE, N.CDINSCESTA,
                                            N.DTEMISSAO, DECODE(CDFISCALNF , '1', I.VRALIQNF, 0) AS VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                            SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                            SUM(I.VRBASECALCNF) AS VRBASECALCNF,
                                            SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                            SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0))   AS VROUTRCRED,
                                            SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1', DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0)) AS VRISENTRIB
                                     FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM
                                     WHERE M.CDEMPRESA       = P_CDEMPRESA                                  AND
                                           M.CDINSCESTA      = P_CDINSCESTA                                 AND
                                           M.DTINIPERIODO    = P_DTINICIAL                                  AND
                                           M.DTFIMPERIODO    = P_DTFINAL                                    AND
                                           M.CDIMPOSTO       = P_CDIMPOSTO                                  AND
                                           I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                               AND
                                           IM.CDIMPOSTONFE   = P_CDIMPOSTO                                  AND
                                           IM.CDIMPOSTO      = I.CDIMPOSTO                                  AND
                                           NVL(I.IDIMPOSTONF, '1') <> '3'                                   AND
                                           N.CDFILIAL        = I.CDFILIAL                                   AND
                                           N.NRLANCTONF      = I.NRLANCTONF                                 AND
                                           N.IDENTRSAIDOP    = 'S'                                          AND
                                           N.IDSTATUS IN ('A','E')                                          AND
                                           NVL(N.IDORIGDESTNF, DECODE(N.IDENTRSAIDOP, 'E', 'F', 'C')) = 'L' AND
                                           NVL(SUBSTR(I.CDFISCOPERNF,1,1),' ') <> '7'                       AND
                                           NVL(N.CDMODDOCFISC, '01') = MD.CDMODDOCFISC                      AND
                                           MD.CDTPREGFISC  = '50'                                           AND
                                           (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                     GROUP BY I.CDFILIAL, I.NRLANCTONF, N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.IDENTRSAIDOP, N.CDINSCESTA,
                                              N.CDFILIRECE, N.DTEMISSAO, DECODE(CDFISCALNF , '1', I.VRALIQNF, 0), I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF) NF
                                WHERE FI.CDFILIAL(+)     = NF.CDFILIRECE           AND
                                      F.CDFILIAL         = NF.CDFILIRECE           AND
                                      EF.CDFILIAL(+)     = F.CDFILIAL              AND
                                      EF.IDTPENDEFILI(+) = NVL(F.IDENDEMISFIL,'P') AND
                                      IE.CDINSCESTA      = NF.CDINSCESTA           AND
                                      IE.CDEMPRESA       = P_CDEMPRESA             AND
                                      NVL(EF.CDPAIS,IE.CDPAIS) = NVL(P_CDPAIS,NVL(EF.CDPAIS,IE.CDPAIS)) AND
                                      (INSTR(NVL(P_SGESTADO, NVL(EF.SGESTADO,IE.SGESTADO)), NVL(EF.SGESTADO,IE.SGESTADO)) > 0) ) NF
                           ORDER BY DATA) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('02'||LPAD(RTRIM(V_CONTADOR), 8, '0'), C_REGISTRO50.DSARQMAG, P_NRSEQARQMAG);
         V_CONTADOR  := NVL(V_CONTADOR,0)+1;
         V_CONTREG   := NVL(V_CONTREG,0) + 1;
         V_CONTGERAL := NVL(V_CONTGERAL,0) + 1;
      END LOOP;
      IF V_CONTREG > 0 THEN
        V_STTOTAL := V_STTOTAL||'50'||LPAD(RTRIM(TO_CHAR(V_CONTREG)),8,'0');
      END IF;
   END IF;
   /* GERAO DO REGISTRO 51 */
   V_CONTREG := 0;
   V_CONTADOR := 0;
   IF SUBSTR(P_REGISTRO,2,1) = 'S' THEN
      FOR C_REGISTRO51 IN (SELECT SUBSTR('51'          ||
                                         NRINSJ        ||
                                         NRINSEST      ||
                                         DATA          ||
                                         SGESTADO      ||
                                         SERIE         ||
                                         NRNOTAFISC    ||
                                         CDFISCOPERNF  ||
                                         VRCONTABILNF  ||
                                         VRIMPOSTONF   ||
                                         VRISENTRIB    ||
                                         VROUTCRED     ||
                                         RPAD(' ',20, ' ')||
                                         IDSTATUS,1,126) AS DSARQUMAG, DATA
                           FROM(
                              SELECT '51',
                                     LPAD(NVL(DECODE(FO.IDTPIJURFORN,'I','','O', '',FO.NRINSJURFORN),'00000000000000'),14,'0') AS NRINSJ,
                                     RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(FO.NRINSESTFORN,'.',''),',',''),'-',''),'/',''),'ISENTO'),14,' ') AS NRINSEST,
                                     TO_CHAR(DECODE(NF.IDENTRSAIDOP, 'S', NF.DTEMISSAO, NF.DTENTRSAID),'yyyymmdd') AS DATA,
                                     RPAD(NVL(EF.SGESTADO,' '),2,' ') AS SGESTADO,
                                     RPAD(DECODE(TRIM(NVL(NF.CDSERIEENTR,NF.CDSERIE)),'-',' ','0',' ',REPLACE(NVL(NF.CDSERIEENTR,NF.CDSERIE), '-', '')),3,' ') AS SERIE,
                                     LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0') AS NRNOTAFISC,
                                     RPAD(NVL(NF.CDFISCOPERNF,'0'),4,' ') AS CDFISCOPERNF,
                                     LTRIM(REPLACE(TO_CHAR(NF.VRCONTABILNF, '00000000000.00'),'.','')) AS VRCONTABILNF,
                                     LTRIM(REPLACE(TO_CHAR(NF.VRIMPOSTONF,'00000000000.00'),'.',''))   AS VRIMPOSTONF,
                                     LTRIM(REPLACE(TO_CHAR(NF.VRISENTRIB, '00000000000.00'),'.',''))   AS VRISENTRIB,
                                     LTRIM(REPLACE(TO_CHAR(NF.VROUTRCRED, '00000000000.00'),'.',''))   AS VROUTCRED,
                                     DECODE(NF.IDSTATUS, 'C', 'S', 'N') AS IDSTATUS
                              FROM
                                 FORNECEDOR FO, ENDEFORN EF, FORNECEDOR FA,
                                 (SELECT I.NRLANCTONF,N.NRNOTAFISC, N.VRNOTAFISC, N.CDSERIEENTR, N.CDSERIE, N.CDFORNECED,
                                         N.DTENTRSAID, N.DTEMISSAO, I.VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDSTATUS, N.IDENTRSAIDOP,
                                         SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                         SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF ,0)) AS VRIMPOSTONF,
                                         SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0)) AS VRISENTRIB,
                                         SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)) AS VROUTRCRED
                                   FROM NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM,
                                        (SELECT DISTINCT IP.CDFILIAL, IP.NRLANCTONF
                                         FROM MAPAAPURAC M, IMPOSTONF IP, IMPOSTO IM
                                         WHERE M.CDEMPRESA     = P_CDEMPRESA     AND
                                               M.CDINSCESTA    = P_CDINSCESTA    AND
                                               M.DTINIPERIODO  = P_DTINICIAL     AND
                                               M.DTFIMPERIODO  = P_DTFINAL       AND
                                               M.CDIMPOSTO     = P_CDIMPOSTO     AND
                                               M.NRSEQUMAPAPU  = IP.NRSEQUMAPAPU AND
                                               IM.CDIMPOSTONFE = P_CDIMPOSTO     AND
                                               IM.CDIMPOSTO    = IP.CDIMPOSTO) IC
                                   WHERE N.CDEMPRESA       = P_CDEMPRESA                   AND
                                         N.CDINSCESTA      = P_CDINSCESTA                  AND
                                         N.DTENTRSAID BETWEEN P_DTINICIAL AND P_DTFINAL    AND
                                         N.IDSTATUS   IN ('A', 'E')                        AND
                                         N.CDFILIAL        = I.CDFILIAL                    AND
                                         N.NRLANCTONF      = I.NRLANCTONF                  AND
                                         IM.CDIMPOSTONFE   = '10'                          AND
                                         IM.CDIMPOSTO      = I.CDIMPOSTO                   AND
                                         I.NRSEQUMAPAPU IS NOT NULL                        AND
                                         I.CDFILIAL        = IC.CDFILIAL                   AND
                                         I.NRLANCTONF      = IC.NRLANCTONF                 AND
                                         NVL(I.IDIMPOSTONF, '1') <> '3'                    AND
                                         NVL(SUBSTR(I.CDFISCOPERNF,1,1),' ') <> '3'        AND
                                         N.CDMODDOCFISC    = MD.CDMODDOCFISC               AND
                                         NVL(MD.CDTPREGFISC, '50') IN ('50', '51')         AND
                                         (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                   GROUP BY I.NRLANCTONF,N.NRNOTAFISC, N.VRNOTAFISC, N.CDSERIEENTR, N.CDSERIE, N.CDFORNECED,
                                            N.DTENTRSAID, N.DTEMISSAO, I.VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDSTATUS, N.IDENTRSAIDOP) NF
                              WHERE FO.CDFORNECED(+)   = NF.CDFORNECED            AND
                                    FA.CDFORNECED      = NF.CDFORNECED            AND
                                    EF.CDFORNECED(+)   = FA.CDFORNECED            AND
                                    EF.IDTPENDEFORN(+) = NVL(FA.IDENDEMISFOR,'P') AND
                                    EF.CDPAIS          = NVL(P_CDPAIS,EF.CDPAIS)  AND
                                    (INSTR(NVL(P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0)
                              UNION ALL
                              SELECT '51',
                                     '00000000000000' AS NRINSJ,
                                     'ISENTO        ' AS NRINSEST,
                                     TO_CHAR(DECODE(NF.IDENTRSAIDOP, 'S', NF.DTEMISSAO, NF.DTENTRSAID),'yyyymmdd') AS DATA,
                                     'EX' AS SGESTADO,
                                     RPAD(DECODE(TRIM(NVL(NF.CDSERIEENTR,NF.CDSERIE)),'-',' ','0',' ',REPLACE(NVL(NF.CDSERIEENTR,NF.CDSERIE), '-', '')),3,' ') AS SERIE,
                                     LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0') AS NRNOTAFISC,
                                     RPAD(NVL(NF.CDFISCOPERNF,'0'),4,' ') AS CDFISCOPERNF,
                                     LTRIM(REPLACE(TO_CHAR(NF.VRCONTABILNF, '00000000000.00'),'.','')) AS VRCONTABILNF,
                                     LTRIM(REPLACE(TO_CHAR(NF.VRIMPOSTONF,'00000000000.00'),'.',''))   AS VRIMPOSTONF,
                                     LTRIM(REPLACE(TO_CHAR(NF.VRISENTRIB, '00000000000.00'),'.',''))   AS VRISENTRIB,
                                     LTRIM(REPLACE(TO_CHAR(NF.VROUTRCRED, '00000000000.00'),'.',''))   AS VROUTCRED,
                                     DECODE(NF.IDSTATUS, 'C', 'S', 'N') AS IDSTATUS
                              FROM
                                 FORNECEDOR FO, ENDEFORN EF, FORNECEDOR FA,
                                 (SELECT I.NRLANCTONF,N.NRNOTAFISC, N.VRNOTAFISC, N.CDSERIEENTR, N.CDSERIE, N.CDFORNECED,
                                         N.DTENTRSAID, N.DTEMISSAO, I.VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDSTATUS, N.IDENTRSAIDOP,
                                         SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                         SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF ,0)) AS VRIMPOSTONF,
                                         SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0)) AS VRISENTRIB,
                                         SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)) AS VROUTRCRED
                                   FROM NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM,
                                        (SELECT DISTINCT IP.CDFILIAL, IP.NRLANCTONF
                                         FROM MAPAAPURAC M, IMPOSTONF IP, IMPOSTO IM
                                         WHERE M.CDEMPRESA     = P_CDEMPRESA     AND
                                               M.CDINSCESTA    = P_CDINSCESTA    AND
                                               M.DTINIPERIODO  = P_DTINICIAL     AND
                                               M.DTFIMPERIODO  = P_DTFINAL       AND
                                               M.CDIMPOSTO     = P_CDIMPOSTO     AND
                                               M.NRSEQUMAPAPU  = IP.NRSEQUMAPAPU AND
                                               IM.CDIMPOSTONFE = P_CDIMPOSTO     AND
                                               IM.CDIMPOSTO    = IP.CDIMPOSTO) IC
                                   WHERE N.CDEMPRESA       = P_CDEMPRESA                   AND
                                         N.CDINSCESTA      = P_CDINSCESTA                  AND
                                         N.DTENTRSAID BETWEEN P_DTINICIAL AND P_DTFINAL    AND
                                         N.IDSTATUS   IN ('A', 'E')                        AND
                                         N.CDFILIAL        = I.CDFILIAL                    AND
                                         N.NRLANCTONF      = I.NRLANCTONF                  AND
                                         IM.CDIMPOSTONFE   = '10'                          AND
                                         IM.CDIMPOSTO      = I.CDIMPOSTO                   AND
                                         I.CDFILIAL        = IC.CDFILIAL                   AND
                                         I.NRLANCTONF      = IC.NRLANCTONF                 AND
                                         NVL(I.IDIMPOSTONF, '1') <> '3'                    AND
                                         I.NRSEQUMAPAPU IS NOT NULL                        AND
                                         SUBSTR(I.CDFISCOPERNF,1,1) = '3'                  AND
                                         N.CDMODDOCFISC    = MD.CDMODDOCFISC               AND
                                         NVL(MD.CDTPREGFISC, '50') IN ('50', '51')         AND
                                         (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                   GROUP BY I.NRLANCTONF,N.NRNOTAFISC, N.VRNOTAFISC, N.CDSERIEENTR, N.CDSERIE, N.CDFORNECED,
                                            N.DTENTRSAID, N.DTEMISSAO, I.VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDSTATUS, N.IDENTRSAIDOP) NF
                              WHERE FO.CDFORNECED(+)   = NF.CDFORNECED            AND
                                    FA.CDFORNECED      = NF.CDFORNECED            AND
                                    EF.CDFORNECED(+)   = FA.CDFORNECED            AND
                                    EF.IDTPENDEFORN(+) = NVL(FA.IDENDEMISFOR,'P') AND
                                    EF.CDPAIS          = NVL(P_CDPAIS,EF.CDPAIS)  AND
                                    (INSTR(NVL(P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0)
                              UNION ALL
                              SELECT '51',
                                     LPAD(NVL(DECODE(CL.IDTPIJURCLIE,'I','','O', '',CL.NRINSJURCLIE),'00000000000000'),14,'0')AS NRINSJ,
                                     RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(CL.NRINSESTCLIE,'.',''),',',''),'-',''),'/',''),'ISENTO'),14,' ')AS NRINSEST,
                                     TO_CHAR(DECODE(NF.IDENTRSAIDOP, 'E', NF.DTENTRSAID, NF.DTEMISSAO),'yyyymmdd') AS DATA,
                                     RPAD(NVL(EC.SGESTADO,' '),2,' ') AS SGESTADO,
                                     RPAD(DECODE(TRIM(NVL(NF.CDSERIE,NF.CDSERIEENTR)),'-',' ','0',' ',REPLACE(NVL(NF.CDSERIE,NF.CDSERIEENTR), '-', '')),3,' ') AS SERIE,
                                     LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0') AS NRNOTAFISC,
                                     RPAD(NVL(NF.CDFISCOPERNF,'0'),4,' ') AS CDFISCOPERNF,
                                     LTRIM(REPLACE(TO_CHAR(NF.VRNOTAFISC, '00000000000.00'),'.','')) AS VRCONTABILNF,
                                     LTRIM(REPLACE(TO_CHAR(NF.VRIMPOSTONF,'00000000000.00'),'.','')) AS VRIMPOSTONF,
                                     LTRIM(REPLACE(TO_CHAR(NF.VROUTRCRED, '00000000000.00'),'.','')) AS VROUTRCRED,
                                     LTRIM(REPLACE(TO_CHAR(NF.VRISENTRIB, '00000000000.00'),'.','')) AS VRISENTRIB,
                                     DECODE(NF.IDSTATUS, 'C', 'S', 'N') AS IDSTATUS
                              FROM
                                 CLIENTE CL, ENDECLIE EC, CLIENTE CA,
                                 (SELECT I.NRLANCTONF,N.NRNOTAFISC, N.VRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDCLIENTE,
                                         N.DTEMISSAO, N.DTENTRSAID, I.VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDSTATUS, N.IDENTRSAIDOP,
                                         SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                         SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF ,0)) AS VRIMPOSTONF,
                                         SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0)) AS VRISENTRIB,
                                         SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)) AS VROUTRCRED
                                   FROM NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM,
                                        (SELECT DISTINCT IP.CDFILIAL, IP.NRLANCTONF
                                         FROM MAPAAPURAC M, IMPOSTONF IP, IMPOSTO IM
                                         WHERE M.CDEMPRESA     = P_CDEMPRESA     AND
                                               M.CDINSCESTA    = P_CDINSCESTA    AND
                                               M.DTINIPERIODO  = P_DTINICIAL     AND
                                               M.DTFIMPERIODO  = P_DTFINAL       AND
                                               M.CDIMPOSTO     = P_CDIMPOSTO     AND
                                               M.NRSEQUMAPAPU  = IP.NRSEQUMAPAPU AND
                                               IM.CDIMPOSTONFE = P_CDIMPOSTO	 AND
                                               IM.CDIMPOSTO    = IP.CDIMPOSTO)IC
                                   WHERE N.CDEMPRESA       = P_CDEMPRESA                   AND
                                         N.CDINSCESTA      = P_CDINSCESTA                  AND
                                         N.DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL     AND
                                         N.IDSTATUS   IN ('A', 'E')                        AND
                                         N.CDFILIAL        = I.CDFILIAL                    AND
                                         N.NRLANCTONF      = I.NRLANCTONF                  AND
                                         IM.CDIMPOSTONFE   = '10'                          AND
                                         IM.CDIMPOSTO      = I.CDIMPOSTO                   AND
                                         I.NRSEQUMAPAPU IS NOT NULL                        AND
                                         I.CDFILIAL        = IC.CDFILIAL                   AND
                                         I.NRLANCTONF      = IC.NRLANCTONF                 AND
                                         NVL(I.IDIMPOSTONF, '1') <> '3'                    AND
                                         NVL(SUBSTR(I.CDFISCOPERNF,1,1),' ') <> '7'        AND
                                         N.CDMODDOCFISC    = MD.CDMODDOCFISC               AND
                                         NVL(MD.CDTPREGFISC, '50') IN ('50', '51')         AND
                                         (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                   GROUP BY I.NRLANCTONF,N.NRNOTAFISC, N.VRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDCLIENTE,
                                            N.DTEMISSAO, N.DTENTRSAID, I.VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDSTATUS, N.IDENTRSAIDOP) NF
                              WHERE CL.CDCLIENTE(+)    = NF.CDCLIENTE             AND
                                    CA.CDCLIENTE       = NF.CDCLIENTE             AND
                                    EC.CDCLIENTE(+)    = CA.CDCLIENTE             AND
                                    EC.IDTPENDECLIE(+) = NVL(CA.IDENDEMISCLI,'P') AND
                                    EC.CDPAIS          = NVL(P_CDPAIS,EC.CDPAIS)  AND
                                    (INSTR(NVL(P_SGESTADO, EC.SGESTADO),EC.SGESTADO) > 0)
                              UNION ALL
                              SELECT '51',
                                     '00000000000000' AS NRINSJ,
                                     'ISENTO        'AS NRINSEST,
                                     TO_CHAR(DECODE(NF.IDENTRSAIDOP, 'E', NF.DTENTRSAID, NF.DTEMISSAO),'yyyymmdd') AS DATA,
                                     'EX' AS SGESTADO,
                                     RPAD(DECODE(TRIM(NVL(NF.CDSERIE,NF.CDSERIEENTR)),'-',' ','0',' ',REPLACE(NVL(NF.CDSERIE,NF.CDSERIEENTR), '-', '')),3,' ') AS SERIE,
                                     LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0') AS NRNOTAFISC,
                                     RPAD(NVL(NF.CDFISCOPERNF,'0'),4,' ') AS CDFISCOPERNF,
                                     LTRIM(REPLACE(TO_CHAR(NF.VRNOTAFISC, '00000000000.00'),'.','')) AS VRCONTABILNF,
                                     LTRIM(REPLACE(TO_CHAR(NF.VRIMPOSTONF,'00000000000.00'),'.','')) AS VRIMPOSTONF,
                                     LTRIM(REPLACE(TO_CHAR(NF.VROUTRCRED, '00000000000.00'),'.','')) AS VROUTRCRED,
                                     LTRIM(REPLACE(TO_CHAR(NF.VRISENTRIB, '00000000000.00'),'.','')) AS VRISENTRIB,
                                     DECODE(NF.IDSTATUS, 'C', 'S', 'N') AS IDSTATUS
                              FROM
                                 CLIENTE CL, ENDECLIE EC, CLIENTE CA,
                                 (SELECT I.NRLANCTONF,N.NRNOTAFISC, N.VRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDCLIENTE,
                                         N.DTEMISSAO, N.DTENTRSAID, I.VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDSTATUS, N.IDENTRSAIDOP,
                                         SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                         SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF ,0)) AS VRIMPOSTONF,
                                         SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0)) AS VRISENTRIB,
                                         SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)) AS VROUTRCRED
                                   FROM NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM,
                                        (SELECT DISTINCT IP.CDFILIAL, IP.NRLANCTONF
                                         FROM MAPAAPURAC M, IMPOSTONF IP, IMPOSTO IM
                                         WHERE M.CDEMPRESA     = P_CDEMPRESA     AND
                                               M.CDINSCESTA    = P_CDINSCESTA    AND
                                               M.DTINIPERIODO  = P_DTINICIAL     AND
                                               M.DTFIMPERIODO  = P_DTFINAL       AND
                                               M.CDIMPOSTO     = P_CDIMPOSTO     AND
                                               M.NRSEQUMAPAPU  = IP.NRSEQUMAPAPU AND
                                               IM.CDIMPOSTONFE = P_CDIMPOSTO     AND
                                               IM.CDIMPOSTO    = IP.CDIMPOSTO) IC
                                   WHERE N.CDEMPRESA       = P_CDEMPRESA                   AND
                                         N.CDINSCESTA      = P_CDINSCESTA                  AND
                                         N.DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL     AND
                                         N.IDSTATUS   IN ('A', 'E')                        AND
                                         N.CDFILIAL        = I.CDFILIAL                    AND
                                         N.NRLANCTONF      = I.NRLANCTONF                  AND
                                         IM.CDIMPOSTONFE   = '10'                          AND
                                         IM.CDIMPOSTO      = I.CDIMPOSTO                   AND
                                         I.NRSEQUMAPAPU IS NOT NULL                        AND
                                         I.CDFILIAL        = IC.CDFILIAL                   AND
                                         I.NRLANCTONF      = IC.NRLANCTONF                 AND
                                         NVL(I.IDIMPOSTONF, '1') <> '3'                    AND
                                         SUBSTR(I.CDFISCOPERNF,1,1) = '7'                  AND
                                         N.CDMODDOCFISC    = MD.CDMODDOCFISC               AND
                                         NVL(MD.CDTPREGFISC, '50') IN ('50', '51')         AND
                                         (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                   GROUP BY I.NRLANCTONF,N.NRNOTAFISC, N.VRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDCLIENTE,
                                            N.DTEMISSAO, N.DTENTRSAID, I.VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDSTATUS, N.IDENTRSAIDOP) NF
                              WHERE CL.CDCLIENTE(+)    = NF.CDCLIENTE             AND
                                    CA.CDCLIENTE       = NF.CDCLIENTE             AND
                                    EC.CDCLIENTE(+)    = CA.CDCLIENTE             AND
                                    EC.IDTPENDECLIE(+) = NVL(CA.IDENDEMISCLI,'P') AND
                                    EC.CDPAIS          = NVL(P_CDPAIS,EC.CDPAIS) AND
                                    (INSTR(NVL(P_SGESTADO, EC.SGESTADO),EC.SGESTADO) > 0)) NF
                           ORDER BY DATA) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('03'||LPAD(RTRIM(V_CONTADOR), 8, '0'), C_REGISTRO51.DSARQUMAG, P_NRSEQARQMAG);
         V_CONTADOR  := NVL(V_CONTADOR,0)+1;
         V_CONTREG   := V_CONTREG + 1;
         V_CONTGERAL := V_CONTGERAL + 1;
      END LOOP;
      IF V_CONTREG > 0 THEN
        V_STTOTAL := V_STTOTAL||'51'||LPAD(RTRIM(TO_CHAR(V_CONTREG) ),8,'0');
      END IF;
   END IF;
   /* GERAO DO REGISTRO 53 */
   V_CONTREG := 0;
   IF SUBSTR(P_REGISTRO,3,1) = 'S' THEN
      FOR C_REGISTRO53 IN (SELECT SUBSTR('53'||
                                  LPAD(NVL(DECODE(CL.IDTPIJURCLIE,'I','','O', '',CL.NRINSJURCLIE),'00000000000000'),14,'0')||
                                  RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(CL.NRINSESTCLIE, ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO'),14,' ')||
                                  TO_CHAR(DECODE(NF.IDENTRSAIDOP, 'E', NF.DTENTRSAID, NF.DTEMISSAO),'yyyymmdd')||
                                  RPAD(NVL(EC.SGESTADO,' '),2,' ')||
                                  RPAD(NVL(NF.CDMODDOCFISC,'01'), 2, ' ')||
                                  RPAD(DECODE(TRIM(NVL(NF.CDSERIE,NF.CDSERIEENTR)),'-',' ','0',' ',REPLACE(NVL(NF.CDSERIE,NF.CDSERIEENTR), '-', '')),3,' ')||
                                  LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0')||
                                  RPAD(NVL(NF.CDFISCOPERNF,'0'),4,' ')||
                                  'P'||
                                  LTRIM(REPLACE(TO_CHAR(ABS(NF.VRBASECALCNF),'00000000000.00'),'.',''))||
                                  LTRIM(REPLACE(TO_CHAR(ABS(NF.VRIMPOSTONF) ,'00000000000.00'),'.',''))||
                                  LTRIM(REPLACE(TO_CHAR(ABS(NF.VRDESPESAS)  ,'00000000000.00'),'.',''))||
                                  'N'||
                                  ' '||
                                  RPAD(' ', 30, ' '), 1, 126) AS DSARQMAG
                           FROM CLIENTE CL, ENDECLIE EC, CLIENTE CA,
                               (SELECT I.CDFILIAL, I.NRLANCTONF,N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDCLIENTE,
                                       N.DTEMISSAO, N.DTENTRSAID, I.VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                       SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                       SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0))   AS VROUTRCRED,
                                       SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0)) AS VRISENTRIB,
                                       0 AS VRDESPESAS
                                FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM,
                                     (SELECT DISTINCT IP.CDFILIAL, IP.NRLANCTONF
                                      FROM MAPAAPURAC M, IMPOSTONF IP, IMPOSTO IM
                                      WHERE M.CDEMPRESA     = P_CDEMPRESA     AND
                                            M.CDINSCESTA    = P_CDINSCESTA    AND
                                            M.DTINIPERIODO  = P_DTINICIAL     AND
                                            M.DTFIMPERIODO  = P_DTFINAL       AND
                                            M.CDIMPOSTO     = P_CDIMPOSTO     AND
                                            M.NRSEQUMAPAPU  = IP.NRSEQUMAPAPU AND
                                            IM.CDIMPOSTONFE = P_CDIMPOSTO     AND
                                            IM.CDIMPOSTO    = IP.CDIMPOSTO) IC
                                WHERE M.CDEMPRESA       = P_CDEMPRESA                   AND
                                      M.CDINSCESTA      = P_CDINSCESTA                  AND
                                      M.DTINIPERIODO    = P_DTINICIAL                   AND
                                      M.DTFIMPERIODO    = P_DTFINAL                     AND
                                      M.CDIMPOSTO       = '80'                          AND
                                      M.NRSEQUMAPAPU    = I.NRSEQUMAPAPU                AND
                                      N.CDFILIAL        = I.CDFILIAL                    AND
                                      N.NRLANCTONF      = I.NRLANCTONF                  AND
                                      I.CDFILIAL        = IC.CDFILIAL                   AND
                                      I.NRLANCTONF      = IC.NRLANCTONF                 AND
                                      IM.CDIMPOSTONFE   = '80'                          AND
                                      IM.CDIMPOSTO      = I.CDIMPOSTO                   AND
                                      N.IDSTATUS IN ('A','E')                           AND
                                      NVL(I.IDIMPOSTONF, '1') <> '3'                    AND
                                      NVL(SUBSTR(I.CDFISCOPERNF,1,1),' ') <> '3'        AND
                                      NVL(SUBSTR(I.CDFISCOPERNF,1,1),' ') <> '7'        AND
                                      NVL(N.CDMODDOCFISC, '01') = MD.CDMODDOCFISC       AND
                                      MD.CDTPREGFISC  = '50'                            AND
                                      (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                GROUP BY I.CDFILIAL, I.NRLANCTONF, N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR,
                                         N.CDCLIENTE,N.DTEMISSAO, N.DTENTRSAID, I.VRALIQNF, I.CDFISCOPERNF,
                                         N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF
                           WHERE CL.CDCLIENTE(+)    = NF.CDCLIENTE                 AND
                                 CA.CDCLIENTE       = NF.CDCLIENTE                 AND
                                 EC.CDCLIENTE(+)    = CA.CDCLIENTE                 AND
                                 EC.IDTPENDECLIE(+) = NVL(CA.IDENDEMISCLI,'P')     AND
                                 EC.CDPAIS          = NVL(P_CDPAIS,EC.CDPAIS)     AND
                                 (INSTR(NVL(P_SGESTADO, EC.SGESTADO), EC.SGESTADO) > 0)
                           UNION ALL
                           SELECT SUBSTR('53'||
                                  LPAD(NVL(DECODE(FO.IDTPIJURFORN,'I','','O', '',FO.NRINSJURFORN),'00000000000000'),14,'0')||
                                  RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(FO.NRINSESTFORN, ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO'),14,' ')||
                                  TO_CHAR(DECODE(NF.IDENTRSAIDOP, 'S', NF.DTEMISSAO, NF.DTENTRSAID),'yyyymmdd')||
                                  RPAD(NVL(EF.SGESTADO,' '),2,' ')||
                                  RPAD(NVL(NF.CDMODDOCFISC,'01'), 2, ' ')||
                                  RPAD(DECODE(TRIM(NVL(NF.CDSERIEENTR,NF.CDSERIE)),'-',' ','0',' ',REPLACE(NVL(NF.CDSERIEENTR,NF.CDSERIE), '-', '')),3,' ')||
                                  LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0')||
                                  RPAD(NVL(NF.CDFISCOPERNF,'0'),4,' ')||
                                  'P'||
                                  LTRIM(REPLACE(TO_CHAR(ABS(NF.VRBASECALCNF),'00000000000.00'),'.',''))||
                                  LTRIM(REPLACE(TO_CHAR(ABS(NF.VRIMPOSTONF) ,'00000000000.00'),'.',''))||
                                  LTRIM(REPLACE(TO_CHAR(ABS(NF.VRDESPESAS)  ,'00000000000.00'),'.',''))||
                                  'N'||
                                  ' '||
                                  RPAD(' ', 30, ' '), 1, 126) AS DSARQMAG
                           FROM FORNECEDOR FO, ENDEFORN EF, FORNECEDOR FA,
                               (SELECT I.CDFILIAL, I.NRLANCTONF,N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFORNECED,
                                       N.DTENTRSAID, N.DTEMISSAO, I.VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP,
                                       SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                       SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0))   AS VROUTRCRED,
                                       SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF, '1', DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0)) AS VRISENTRIB,
                                       0 AS VRDESPESAS
                                FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM,
                                     (SELECT DISTINCT IP.CDFILIAL, IP.NRLANCTONF
                                      FROM MAPAAPURAC M, IMPOSTONF IP, IMPOSTO IM
                                      WHERE M.CDEMPRESA     = P_CDEMPRESA     AND
                                            M.CDINSCESTA    = P_CDINSCESTA    AND
                                            M.DTINIPERIODO  = P_DTINICIAL     AND
                                            M.DTFIMPERIODO  = P_DTFINAL       AND
                                            M.CDIMPOSTO     = P_CDIMPOSTO     AND
                                            M.NRSEQUMAPAPU  = IP.NRSEQUMAPAPU AND
                                            IM.CDIMPOSTONFE = P_CDIMPOSTO     AND
                                            IM.CDIMPOSTO    = IP.CDIMPOSTO) IC
                                WHERE M.CDEMPRESA       = P_CDEMPRESA                   AND
                                      M.CDINSCESTA      = P_CDINSCESTA                  AND
                                      M.DTINIPERIODO    = P_DTINICIAL                   AND
                                      M.DTFIMPERIODO    = P_DTFINAL                     AND
                                      M.CDIMPOSTO       = '80'                          AND
                                      M.NRSEQUMAPAPU    = I.NRSEQUMAPAPU                AND
                                      N.CDFILIAL        = I.CDFILIAL                    AND
                                      N.NRLANCTONF      = I.NRLANCTONF                  AND
                                      I.CDFILIAL        = IC.CDFILIAL                   AND
                                      I.NRLANCTONF      = IC.NRLANCTONF                 AND
                                      IM.CDIMPOSTONFE   = '80'                          AND
                                      IM.CDIMPOSTO      = I.CDIMPOSTO                   AND
                                      N.IDSTATUS IN ('A','E')                           AND
                                      NVL(I.IDIMPOSTONF, '1') <> '3'                    AND
                                      NVL(SUBSTR(I.CDFISCOPERNF,1,1),' ') <> '3'        AND
                                      NVL(SUBSTR(I.CDFISCOPERNF,1,1),' ') <> '7'        AND
                                      NVL(N.CDMODDOCFISC, '01')  = MD.CDMODDOCFISC      AND
                                      MD.CDTPREGFISC  = '50'                            AND
                                      (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                GROUP BY I.CDFILIAL, I.NRLANCTONF, N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR,
                                         N.CDFORNECED,N.DTENTRSAID, N.DTEMISSAO, I.VRALIQNF, I.CDFISCOPERNF,
                                         N.CDMODDOCFISC, N.IDORIGDESTNF, N.IDENTRSAIDOP) NF
                           WHERE FO.CDFORNECED(+)   = NF.CDFORNECED            AND
                                 FA.CDFORNECED      = NF.CDFORNECED            AND
                                 EF.CDFORNECED(+)   = FA.CDFORNECED            AND
                                 EF.IDTPENDEFORN(+) = NVL(FA.IDENDEMISFOR,'P') AND
                                 EF.CDPAIS          = NVL(P_CDPAIS,EF.CDPAIS)  AND
                                 (INSTR(NVL(P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0)
                           UNION ALL
                           SELECT SUBSTR('53'||
                                  RPAD(NVL(REPLACE(REPLACE(REPLACE(FI.NRINSJURFILI, '-', ''), '.', ''), '/', ''),'00000000000000'),14,' ')||
                                  RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(DECODE(SUBSTR(UPPER(FI.CDINSCESTA),1,5),'ISENT','ISENTO',FI.CDINSCESTA), ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO'),14,' ')||
                                  TO_CHAR(NF.DTENTRSAID,'yyyymmdd')||
                                  RPAD(NVL(DECODE(NVL(F.IDENDEMISFIL,'P'),'I',IE.CDINSCESTA,EF.SGESTADO),' '),2,' ')||
                                  RPAD(NVL(NF.CDMODDOCFISC,'01'), 2, ' ')||
                                  RPAD(DECODE(TRIM(NVL(NF.CDSERIE,NF.CDSERIEENTR)),'-',' ','0',' ',REPLACE(NVL(NF.CDSERIE,NF.CDSERIEENTR), '-', '')),3,' ')||
                                  LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0')||
                                  RPAD(NVL(NF.CDFISCOPERNF,'0'),4,' ')||
                                  'P'||
                                  LTRIM(REPLACE(TO_CHAR(ABS(NF.VRBASECALCNF),'00000000000.00'),'.',''))||
                                  LTRIM(REPLACE(TO_CHAR(ABS(NF.VRIMPOSTONF) ,'00000000000.00'),'.',''))||
                                  LTRIM(REPLACE(TO_CHAR(ABS(NF.VRDESPESAS)  ,'00000000000.00'),'.',''))||
                                  'N'||
                                  ' '||
                                  RPAD(' ', 30, ' '), 1, 126) AS DSARQMAG
                           FROM FILIAL FI, ENDEFILI EF, FILIAL F, INSCRESTAD IE,
                               (SELECT I.CDFILIAL, I.NRLANCTONF,N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFILIEMIT,
                                       N.DTENTRSAID, I.VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF,
                                       SUM(I.VRCONTABILNF) AS VRCONTABILNF, N.CDINSCESTA,
                                       SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                       SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0))   AS VROUTRCRED,
                                       SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF, '1', DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0)) AS VRISENTRIB,
                                       0 AS VRDESPESAS
                                FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM,
                                     (SELECT DISTINCT IP.CDFILIAL, IP.NRLANCTONF
                                      FROM MAPAAPURAC M, IMPOSTONF IP, IMPOSTO IM
                                      WHERE M.CDEMPRESA     = P_CDEMPRESA     AND
                                            M.CDINSCESTA    = P_CDINSCESTA    AND
                                            M.DTINIPERIODO  = P_DTINICIAL     AND
                                            M.DTFIMPERIODO  = P_DTFINAL       AND
                                            M.CDIMPOSTO     = P_CDIMPOSTO     AND
                                            M.NRSEQUMAPAPU  = IP.NRSEQUMAPAPU AND
                                            IM.CDIMPOSTONFE = P_CDIMPOSTO     AND
                                            IM.CDIMPOSTO    = IP.CDIMPOSTO) IC
                                WHERE M.CDEMPRESA       = P_CDEMPRESA                                  AND
                                      M.CDINSCESTA      = P_CDINSCESTA                                 AND
                                      M.DTINIPERIODO    = P_DTINICIAL                                  AND
                                      M.DTFIMPERIODO    = P_DTFINAL                                    AND
                                      M.CDIMPOSTO       = '80'                                         AND
                                      M.NRSEQUMAPAPU    = I.NRSEQUMAPAPU                               AND
                                      N.IDENTRSAIDOP    = 'E'                                          AND
                                      NVL(N.IDORIGDESTNF, DECODE(N.IDENTRSAIDOP, 'E', 'F', 'C')) = 'L' AND
                                      N.CDFILIAL        = I.CDFILIAL                                   AND
                                      N.NRLANCTONF      = I.NRLANCTONF                                 AND
                                      I.CDFILIAL        = IC.CDFILIAL                                  AND
                                      I.NRLANCTONF      = IC.NRLANCTONF                                AND
                                      IM.CDIMPOSTONFE   = '80'                                         AND
                                      IM.CDIMPOSTO      = I.CDIMPOSTO                                  AND
                                      NVL(I.IDIMPOSTONF, '1') <> '3'                                   AND
                                      N.IDSTATUS IN ('A','E')                                          AND
                                      NVL(SUBSTR(I.CDFISCOPERNF,1,1),' ') <> '3'                       AND
                                      NVL(N.CDMODDOCFISC, '01') = MD.CDMODDOCFISC                      AND
                                      MD.CDTPREGFISC  = '50'                                           AND
                                      (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                GROUP BY I.CDFILIAL, I.NRLANCTONF, N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFILIEMIT, N.CDINSCESTA,
                                         N.DTENTRSAID, I.VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF) NF
                           WHERE FI.CDFILIAL(+)     = NF.CDFILIEMIT           AND
                                 F.CDFILIAL         = NF.CDFILIEMIT           AND
                                 EF.CDFILIAL(+)     = F.CDFILIAL              AND
                                 EF.IDTPENDEFILI(+) = NVL(F.IDENDEMISFIL,'P') AND
                                 IE.CDINSCESTA      = NF.CDINSCESTA           AND
                                 IE.CDEMPRESA       = P_CDEMPRESA             AND
                                 NVL(EF.CDPAIS,IE.CDPAIS) = NVL(P_CDPAIS,NVL(EF.CDPAIS,IE.CDPAIS)) AND
                                 (INSTR(NVL(P_SGESTADO, NVL(EF.SGESTADO,IE.SGESTADO)), NVL(EF.SGESTADO,IE.SGESTADO)) > 0)
                           UNION ALL
                           SELECT SUBSTR('53'||
                                  RPAD(NVL(REPLACE(REPLACE(REPLACE(FI.NRINSJURFILI, '-', ''), '.', ''), '/', ''),'00000000000000'),14,' ')||
                                  RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(DECODE(SUBSTR(UPPER(FI.CDINSCESTA),1,5),'ISENT','ISENTO',FI.CDINSCESTA), ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO'),14,' ')||
                                  TO_CHAR(NF.DTEMISSAO,'yyyymmdd')||
                                  RPAD(NVL(DECODE(NVL(F.IDENDEMISFIL,'P'),'I',IE.SGESTADO,EF.SGESTADO),' '),2,' ')||
                                  RPAD(NVL(NF.CDMODDOCFISC,'01'), 2, ' ')||
                                  RPAD(DECODE(TRIM(NVL(NF.CDSERIE,NF.CDSERIEENTR)),'-',' ','0',' ',REPLACE(NVL(NF.CDSERIE,NF.CDSERIEENTR), '-', '')),3,' ')||
                                  LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0')||
                                  RPAD(NVL(NF.CDFISCOPERNF,'0'),4,' ')||
                                  'P'||
                                  LTRIM(REPLACE(TO_CHAR(ABS(NF.VRBASECALCNF),'00000000000.00'),'.',''))||
                                  LTRIM(REPLACE(TO_CHAR(ABS(NF.VRIMPOSTONF) ,'00000000000.00'),'.',''))||
                                  LTRIM(REPLACE(TO_CHAR(ABS(NF.VRDESPESAS)  ,'00000000000.00'),'.',''))||
                                  'N'||
                                  ' '||
                                  RPAD(' ', 30, ' '), 1, 126) AS DSARQMAG
                           FROM FILIAL FI, ENDEFILI EF, FILIAL F, INSCRESTAD IE,
                               (SELECT I.CDFILIAL, I.NRLANCTONF,N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDFILIRECE,
                                       N.DTEMISSAO, I.VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF,
                                       SUM(I.VRCONTABILNF) AS VRCONTABILNF, N.CDINSCESTA,
                                       SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                       SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0))   AS VROUTRCRED,
                                       SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1', DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0)) AS VRISENTRIB,
                                       0 AS VRDESPESAS
                                FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM,
                                     (SELECT DISTINCT IP.CDFILIAL, IP.NRLANCTONF
                                      FROM MAPAAPURAC M, IMPOSTONF IP, IMPOSTO IM
                                      WHERE M.CDEMPRESA     = P_CDEMPRESA     AND
                                            M.CDINSCESTA    = P_CDINSCESTA    AND
                                            M.DTINIPERIODO  = P_DTINICIAL     AND
                                            M.DTFIMPERIODO  = P_DTFINAL       AND
                                            M.CDIMPOSTO     = P_CDIMPOSTO     AND
                                            M.NRSEQUMAPAPU  = IP.NRSEQUMAPAPU AND
                                            IM.CDIMPOSTONFE = P_CDIMPOSTO     AND
                                            IM.CDIMPOSTO    = IP.CDIMPOSTO)IC
                                WHERE M.CDEMPRESA       = P_CDEMPRESA                                  AND
                                      M.CDINSCESTA      = P_CDINSCESTA                                 AND
                                      M.DTINIPERIODO    = P_DTINICIAL                                  AND
                                      M.DTFIMPERIODO    = P_DTFINAL                                    AND
                                      M.CDIMPOSTO       = '80'                                         AND
                                      M.NRSEQUMAPAPU    = I.NRSEQUMAPAPU                               AND
                                      N.IDENTRSAIDOP    = 'S'                                          AND
                                      NVL(N.IDORIGDESTNF, DECODE(N.IDENTRSAIDOP, 'E', 'F', 'C')) = 'L' AND
                                      N.CDFILIAL        = I.CDFILIAL                                   AND
                                      N.NRLANCTONF      = I.NRLANCTONF                                 AND
                                      I.CDFILIAL        = IC.CDFILIAL                                  AND
                                      I.NRLANCTONF      = IC.NRLANCTONF                                AND
                                      IM.CDIMPOSTONFE   = '80'                                         AND
                                      IM.CDIMPOSTO      = I.CDIMPOSTO                                  AND
                                      N.IDSTATUS IN ('A','E')                                          AND
                                      NVL(I.IDIMPOSTONF, '1') <> '3'                                   AND
                                      NVL(SUBSTR(I.CDFISCOPERNF,1,1),' ') <> '7'                       AND
                                      NVL(N.CDMODDOCFISC, '01') = MD.CDMODDOCFISC                      AND
                                      MD.CDTPREGFISC  = '50'                                           AND
                                      (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                       NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                GROUP BY I.CDFILIAL, I.NRLANCTONF, N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR, N.CDINSCESTA,
                                         N.CDFILIRECE, N.DTEMISSAO, I.VRALIQNF, I.CDFISCOPERNF,N.CDMODDOCFISC, N.IDORIGDESTNF) NF
                           WHERE FI.CDFILIAL(+)     = NF.CDFILIRECE           AND
                                 F.CDFILIAL         = NF.CDFILIRECE           AND
                                 EF.CDFILIAL(+)     = F.CDFILIAL              AND
                                 EF.IDTPENDEFILI(+) = NVL(F.IDENDEMISFIL,'P') AND
                                 IE.CDINSCESTA      = NF.CDINSCESTA           AND
                                 IE.CDEMPRESA       = P_CDEMPRESA             AND
                                 NVL(EF.CDPAIS,IE.CDPAIS) = NVL(P_CDPAIS,NVL(EF.CDPAIS,IE.CDPAIS)) AND
                                 (INSTR(NVL(P_SGESTADO, NVL(EF.SGESTADO,IE.SGESTADO)), NVL(EF.SGESTADO,IE.SGESTADO)) > 0)) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('04'||LPAD(RTRIM('00'), 8, '0'), C_REGISTRO53.DSARQMAG, P_NRSEQARQMAG);
         V_CONTREG := V_CONTREG+1;
         V_CONTGERAL := V_CONTGERAL + 1;
      END LOOP;
      IF V_CONTREG > 0 THEN
        V_STTOTAL := V_STTOTAL||'53'||LPAD(RTRIM(TO_CHAR(V_CONTREG)),8,'0');
      END IF;
   END IF;
   /* GERAO DO REGISTRO 54 */
   V_CONTREG := 0;
   V_SEQUENCIAL := 0;
   IF SUBSTR(P_REGISTRO,4,1) = 'S' THEN
      V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
      V_CDFILIAL   := ' ';
      V_NRLANCTONF := ' ';
      FOR C_REGISTRO54A IN (SELECT
                                ('54'||
                                 LPAD(NVL(IT.NRINSJURNF, '00000000000000'),14,'0')||
                                 RPAD(NVL(IT.CDMODDOCFISC,'01'), 2, ' ')||
                                 RPAD(DECODE(RTRIM(NVL(IT.CDSERIE,' ')),'-',' ','0',' ',REPLACE(NVL(IT.CDSERIE,' '),'-', '')),3,' ')||
                                 LPAD(SUBSTR(IT.NRNOTAFISC,LENGTH(IT.NRNOTAFISC)-5,6),6,'0')||
                                 RPAD(NVL(IT.CDFISCOPERNF,'0'),4,' ')||
                                 LPAD(NVL(TRIM(IT.CDSITUTRIBPR),'0'),3,'0')) AS DSINICIO,
                                (RPAD(PR.CDARVPROD,14,' ')||
                                 LTRIM(REPLACE(TO_CHAR(ABS(IT.QTITEMPROD),'00000000.000'),'.',''))||
                                 LTRIM(REPLACE(TO_CHAR(ABS(IT.VRPRODUTO) ,'0000000000.00'),'.',''))||
                                 LTRIM(REPLACE(TO_CHAR(ABS(IT.VRDESCITEM),'0000000000.00'),'.',''))||
                                 LTRIM(REPLACE(TO_CHAR(NVL(ABS(IT.VRBASECALCIT),0),'0000000000.00'),'.',''))||
                                 '000000000000' ||
                                 LTRIM(REPLACE(TO_CHAR(NVL(ABS(VALOR_IMPOSTO_ITEM_NFE(IT.CDFILIAL, IT.NRLANCTONF, IT.NRSEQITPROD, '10', 'A')),0),'0000000000.00'),'.',''))||
                                 LTRIM(REPLACE(TO_CHAR(NVL(ABS(IT.VRALIQITEM),0),'00.00'),'.',''))) AS DSARQMAG,
                                 PR.CDARVPROD, NVL(IT.CDPRODNCMTRANS, PR.CDCLASFISC) AS CDCLASFISC, PR.NMPRODUTO, NVL(PR.SGUNIDADE, '  ') AS SGUNIDADE, NVL(IT.CDSITUTRIBPR, '   ') AS CDSITUTRIBPR,
                                 ABS(NVL(VALOR_IMPOSTO_ITEM_NFE(IT.CDFILIAL, IT.NRLANCTONF, IT.NRSEQITPROD, '10', 'A'),0)) AS VRALIQIPI,
                                 NVL(IT.VRALIQITEM,0) AS VRALIQICMS, NVL(IT.VRPERREDBCIT,0) VRPERREDBCIT,
                                 IT.CDFILIAL, IT.NRLANCTONF, IT.NRSEQITPROD
                             FROM PRODUTO PR,
                                  (SELECT /*+ INDEX(PK_ITEMPROIMPOS) II*/
                                          NF.CDFILIAL, NF.NRLANCTONF, DECODE(CL.IDTPIJURCLIE,'I','','O', '',CL.NRINSJURCLIE) AS NRINSJURNF, NF.DTEMISSAO,
                                          NF.CDMODDOCFISC, NVL(NF.CDSERIE, NF.CDSERIEENTR) CDSERIE,
                                          EC.SGESTADO, NF.NRNOTAFISC, IT.NRSEQITPROD,
                                          IT.CDPRODUTO, LPAD(CDSITUTRIBPR,3,'0') CDSITUTRIBPR,
                                          IT.QTITEMPROD, SUM(II.VRCONTITIMP) VRPRODUTO, IT.VRTOTAITEM, IT.VRDESCITEM,
                                          MAX(DECODE(CDFISCALIT, '1', II.VRALIQITEM, 0)) AS VRALIQITEM,
                                          DECODE(CDFISCALIT, '1', II.VRBASECALCIT, 0) AS VRBASECALCIT,
                                          MAX(IT.CDFISOPEITEM) AS CDFISCOPERNF, MAX(II.VRPERREDBCIT) AS VRPERREDBCIT,
                                          IT.CDPRODNCMTRANS
                                   FROM NOTAFISCAL NF, ITEMPRODUTO IT, ITEMPROIMPOS II, IMPOSTO IM,
                                        CLIENTE CL, ENDECLIE EC, MODDOCFISC MD,
                                     (SELECT DISTINCT IP.CDFILIAL, IP.NRLANCTONF
                                      FROM MAPAAPURAC M, IMPOSTONF IP, IMPOSTO IM
                                      WHERE M.CDEMPRESA     = P_CDEMPRESA     AND
                                            M.CDINSCESTA    = P_CDINSCESTA    AND
                                            M.DTINIPERIODO  = P_DTINICIAL     AND
                                            M.DTFIMPERIODO  = P_DTFINAL       AND
                                            M.CDIMPOSTO     = P_CDIMPOSTO     AND
                                            M.NRSEQUMAPAPU  = IP.NRSEQUMAPAPU AND
                                            IM.CDIMPOSTONFE = P_CDIMPOSTO     AND
                                            IM.CDIMPOSTO    = IP.CDIMPOSTO) IP
                                   WHERE NVL(NF.IDORIGDESTNF, DECODE(NF.IDENTRSAIDOP, 'E', 'F', 'C')) = 'C' AND
                                         NF.CDFILIAL        = IP.CDFILIAL                  AND
                                         NF.NRLANCTONF      = IP.NRLANCTONF                AND
                                         NF.CDFILIAL        = IT.CDFILIAL                  AND
                                         NF.NRLANCTONF      = IT.NRLANCTONF                AND
                                         NF.IDSTATUS IN ('A','E')                          AND
                                         II.CDFILIAL        = IT.CDFILIAL                  AND
                                         II.NRLANCTONF      = IT.NRLANCTONF                AND
                                         II.NRSEQITPROD     = IT.NRSEQITPROD               AND
                                         IM.CDIMPOSTONFE    = P_CDIMPOSTO                  AND
                                         IM.CDIMPOSTO       = II.CDIMPOSTO                 AND
                                         II.NRITPROIMPOS    <> '3'                         AND
                                         SUBSTR(NVL(II.CDFISCOPERIT,' '),1,1) <> '7'       AND
                                         CL.CDCLIENTE(+)    = NF.CDCLIENTE                 AND
                                         EC.CDCLIENTE(+)    = CL.CDCLIENTE                 AND
                                         EC.IDTPENDECLIE(+) = NVL(CL.IDENDEMISCLI,'P')     AND
                                         EC.CDPAIS          = NVL(P_CDPAIS,EC.CDPAIS)      AND
                                         (INSTR(NVL(P_SGESTADO, EC.SGESTADO), EC.SGESTADO) > 0) AND
                                         NF.CDMODDOCFISC    = MD.CDMODDOCFISC              AND
                                         NVL(MD.CDTPREGFISC, '50')  = '50'                 AND
                                         (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                   GROUP BY NF.CDFILIAL, NF.NRLANCTONF, DECODE(CL.IDTPIJURCLIE,'I','','O', '',CL.NRINSJURCLIE), NF.DTEMISSAO,
                                            NF.CDMODDOCFISC, NVL(NF.CDSERIE, NF.CDSERIEENTR),
                                            EC.SGESTADO, NF.NRNOTAFISC, IT.NRSEQITPROD,
                                            IT.CDPRODUTO, CDSITUTRIBPR, IT.QTITEMPROD, IT.VRTOTAITEM,
                                            IT.VRDESCITEM, DECODE(CDFISCALIT, '1', II.VRBASECALCIT, 0), IT.CDPRODNCMTRANS
                                   UNION ALL
                                   SELECT /*+ INDEX(PK_ITEMPROIMPOS) II*/
                                          NF.CDFILIAL, NF.NRLANCTONF, '00000000000000' NRINSJURNF, NF.DTEMISSAO,
                                          NF.CDMODDOCFISC, NVL(NF.CDSERIE, NF.CDSERIEENTR) CDSERIE,
                                          'EX' SGESTADO, NF.NRNOTAFISC, IT.NRSEQITPROD,
                                          IT.CDPRODUTO, LPAD(CDSITUTRIBPR,3,'0') CDSITUTRIBPR,
                                          IT.QTITEMPROD, SUM(II.VRCONTITIMP) VRPRODUTO, IT.VRTOTAITEM, IT.VRDESCITEM,
                                          MAX(DECODE(CDFISCALIT, '1', II.VRALIQITEM, 0)) AS VRALIQITEM,
                                          DECODE(CDFISCALIT, '1', II.VRBASECALCIT, 0) AS VRBASECALCIT,
                                          MAX(IT.CDFISOPEITEM) AS CDFISCOPERNF, MAX(II.VRPERREDBCIT) AS VRPERREDBCIT,
                                          IT.CDPRODNCMTRANS
                                   FROM NOTAFISCAL NF, ITEMPRODUTO IT, ITEMPROIMPOS II,
                                        CLIENTE CL, ENDECLIE EC, MODDOCFISC MD, IMPOSTO IM,
                                     (SELECT DISTINCT IP.CDFILIAL, IP.NRLANCTONF
                                      FROM MAPAAPURAC M, IMPOSTONF IP, IMPOSTO IM
                                      WHERE M.CDEMPRESA     = P_CDEMPRESA     AND
                                            M.CDINSCESTA    = P_CDINSCESTA    AND
                                            M.DTINIPERIODO  = P_DTINICIAL     AND
                                            M.DTFIMPERIODO  = P_DTFINAL       AND
                                            M.CDIMPOSTO     = P_CDIMPOSTO     AND
                                            M.NRSEQUMAPAPU  = IP.NRSEQUMAPAPU AND
                                            IM.CDIMPOSTONFE = P_CDIMPOSTO     AND
                                            IM.CDIMPOSTO    = IP.CDIMPOSTO) IP
                                   WHERE NVL(NF.IDORIGDESTNF, DECODE(NF.IDENTRSAIDOP, 'E', 'F', 'C')) = 'C' AND
                                         NF.CDFILIAL        = IP.CDFILIAL                       AND
                                         NF.NRLANCTONF      = IP.NRLANCTONF                     AND
                                         NF.CDFILIAL        = IT.CDFILIAL                       AND
                                         NF.NRLANCTONF      = IT.NRLANCTONF                     AND
                                         NF.IDSTATUS IN ('A','E')                               AND
                                         II.CDFILIAL        = IT.CDFILIAL                       AND
                                         II.NRLANCTONF      = IT.NRLANCTONF                     AND
                                         II.NRSEQITPROD     = IT.NRSEQITPROD                    AND
                                         IM.CDIMPOSTONFE    = P_CDIMPOSTO                       AND
                                         IM.CDIMPOSTO       = II.CDIMPOSTO                      AND
                                         II.NRITPROIMPOS    <> '3'                              AND
                                         SUBSTR(II.CDFISCOPERIT, 1, 1) = '7'                    AND
                                         CL.CDCLIENTE(+)    = NF.CDCLIENTE                      AND
                                         EC.CDCLIENTE(+)    = CL.CDCLIENTE                      AND
                                         EC.IDTPENDECLIE(+) = NVL(CL.IDENDEMISCLI,'P')          AND
                                         EC.CDPAIS          = NVL(P_CDPAIS,EC.CDPAIS)           AND
                                         (INSTR(NVL(P_SGESTADO, EC.SGESTADO), EC.SGESTADO) > 0) AND
                                         NF.CDMODDOCFISC    = MD.CDMODDOCFISC                   AND
                                         NVL(MD.CDTPREGFISC, '50')  = '50'                      AND
                                         (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                   GROUP BY NF.CDFILIAL, NF.NRLANCTONF, NF.DTEMISSAO,
                                            NF.CDMODDOCFISC, NVL(NF.CDSERIE, NF.CDSERIEENTR),
                                            NF.NRNOTAFISC, IT.NRSEQITPROD,
                                            IT.CDPRODUTO, CDSITUTRIBPR, IT.QTITEMPROD, IT.VRTOTAITEM,
                                            IT.VRDESCITEM, DECODE(CDFISCALIT, '1', II.VRBASECALCIT, 0), IT.CDPRODNCMTRANS
                                   UNION ALL
                                   SELECT /*+ INDEX(PK_ITEMPROIMPOS) II*/
                                          NF.CDFILIAL, NF.NRLANCTONF, NF.NRINSJURNF AS NRINSJURNF, NF.DTEMISSAO,
                                          NF.CDMODDOCFISC, NVL(NF.CDSERIE, NF.CDSERIEENTR) CDSERIE,
                                          'EX' SGESTADO, NF.NRNOTAFISC, IT.NRSEQITPROD,
                                          IT.CDPRODUTO, LPAD(CDSITUTRIBPR,3,'0') CDSITUTRIBPR,
                                          IT.QTITEMPROD, SUM(II.VRCONTITIMP) VRPRODUTO, IT.VRTOTAITEM, IT.VRDESCITEM,
                                          MAX(DECODE(CDFISCALIT, '1', II.VRALIQITEM, 0)) AS VRALIQITEM,
                                          DECODE(CDFISCALIT, '1', II.VRBASECALCIT, 0)  AS VRBASECALCIT,
                                          MAX(IT.CDFISOPEITEM) AS CDFISCOPERNF, MAX(II.VRPERREDBCIT) AS VRPERREDBCIT,
                                          IT.CDPRODNCMTRANS
                                   FROM NOTAFISCAL NF, ITEMPRODUTO IT, ITEMPROIMPOS II, IMPOSTO IM,
                                        FORNECEDOR FO, ENDEFORN EF, MODDOCFISC MD,
                                     (SELECT DISTINCT IP.CDFILIAL, IP.NRLANCTONF
                                      FROM MAPAAPURAC M, IMPOSTONF IP, IMPOSTO IM
                                      WHERE M.CDEMPRESA     = P_CDEMPRESA
                                        AND M.CDINSCESTA    = P_CDINSCESTA
                                        AND M.DTINIPERIODO  = P_DTINICIAL
                                        AND M.DTFIMPERIODO  = P_DTFINAL
                                        AND M.CDIMPOSTO     = P_CDIMPOSTO
                                        AND M.NRSEQUMAPAPU  = IP.NRSEQUMAPAPU
                                        AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                        AND IM.CDIMPOSTO    = IP.CDIMPOSTO)IP
                                   WHERE NVL(NF.IDORIGDESTNF, DECODE(NF.IDENTRSAIDOP, 'E', 'F', 'C')) = 'F'
                                     AND NF.CDFILIAL        = IP.CDFILIAL
                                     AND NF.NRLANCTONF      = IP.NRLANCTONF
                                     AND NF.CDFILIAL        = IT.CDFILIAL
                                     AND NF.NRLANCTONF      = IT.NRLANCTONF
                                     AND NF.IDSTATUS IN ('A','E')
                                     AND II.CDFILIAL        = IT.CDFILIAL
                                     AND II.NRLANCTONF      = IT.NRLANCTONF
                                     AND II.NRSEQITPROD     = IT.NRSEQITPROD
                                     AND IM.CDIMPOSTONFE    = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO       = II.CDIMPOSTO
                                     AND II.NRITPROIMPOS    <> '3'
                                     AND SUBSTR(II.CDFISCOPERIT, 1, 1) = '3'
                                     AND FO.CDFORNECED(+)    = NF.CDFORNECED
                                     AND EF.CDFORNECED(+)    = FO.CDFORNECED
                                     AND EF.IDTPENDEFORN(+) = NVL(FO.IDENDEMISFOR,'P')
                                     AND EF.CDPAIS          = NVL(P_CDPAIS,EF.CDPAIS)
                                     AND (INSTR(NVL(P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0)
                                     AND NF.CDMODDOCFISC    = MD.CDMODDOCFISC
                                     AND NVL(MD.CDTPREGFISC, '50')  = '50'
                                     AND (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                   GROUP BY NF.CDFILIAL, NF.NRLANCTONF, NF.DTEMISSAO,
                                            NF.CDMODDOCFISC, NVL(NF.CDSERIE, NF.CDSERIEENTR),
                                            NF.NRNOTAFISC, IT.NRSEQITPROD,
                                            IT.CDPRODUTO, CDSITUTRIBPR, IT.QTITEMPROD, IT.VRTOTAITEM,
                                            IT.VRDESCITEM, NF.NRINSJURNF, DECODE(CDFISCALIT, '1', II.VRBASECALCIT, 0), IT.CDPRODNCMTRANS
                                   UNION ALL
                                   SELECT /*+ INDEX(PK_ITEMPROIMPOS) II*/
                                          NF.CDFILIAL, NF.NRLANCTONF, NF.NRINSJURNF AS NRINSJURNF, NF.DTEMISSAO,
                                          NF.CDMODDOCFISC, NVL(NF.CDSERIE, NF.CDSERIEENTR) CDSERIE,
                                          'EX' SGESTADO, NF.NRNOTAFISC, IT.NRSEQITPROD,
                                          IT.CDPRODUTO, LPAD(CDSITUTRIBPR,3,'0') CDSITUTRIBPR,
                                          IT.QTITEMPROD, SUM(II.VRCONTITIMP) VRPRODUTO, IT.VRTOTAITEM, IT.VRDESCITEM,
                                          MAX(DECODE(CDFISCALIT, '1', II.VRALIQITEM, 0)) AS VRALIQITEM,
                                          DECODE(CDFISCALIT, '1', II.VRBASECALCIT, 0)  AS VRBASECALCIT,
                                          MAX(IT.CDFISOPEITEM) AS CDFISCOPERNF, MAX(II.VRPERREDBCIT) AS VRPERREDBCIT,
                                          IT.CDPRODNCMTRANS
                                   FROM NOTAFISCAL NF, ITEMPRODUTO IT, ITEMPROIMPOS II, IMPOSTO IM,
                                        FORNECEDOR FO, ENDEFORN EF, MODDOCFISC MD,
                                     (SELECT DISTINCT IP.CDFILIAL, IP.NRLANCTONF
                                      FROM MAPAAPURAC M, IMPOSTONF IP, IMPOSTO IM
                                      WHERE M.CDEMPRESA     = P_CDEMPRESA
                                        AND M.CDINSCESTA    = P_CDINSCESTA
                                        AND M.DTINIPERIODO  = P_DTINICIAL
                                        AND M.DTFIMPERIODO  = P_DTFINAL
                                        AND M.CDIMPOSTO     = P_CDIMPOSTO
                                        AND M.NRSEQUMAPAPU  = IP.NRSEQUMAPAPU
                                        AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                        AND IM.CDIMPOSTO    = IP.CDIMPOSTO) IP
                                   WHERE NVL(NF.IDORIGDESTNF, DECODE(NF.IDENTRSAIDOP, 'E', 'F', 'C')) = 'F'
                                     AND NF.CDFILIAL        = IP.CDFILIAL
                                     AND NF.NRLANCTONF      = IP.NRLANCTONF
                                     AND NF.CDFILIAL        = IT.CDFILIAL
                                     AND NF.NRLANCTONF      = IT.NRLANCTONF
                                     AND NF.IDSTATUS IN ('A','E')
                                     AND II.CDFILIAL        = IT.CDFILIAL
                                     AND II.NRLANCTONF      = IT.NRLANCTONF
                                     AND II.NRSEQITPROD     = IT.NRSEQITPROD
                                     AND IM.CDIMPOSTONFE    = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO       = II.CDIMPOSTO
                                     AND II.NRITPROIMPOS    <> '3'
                                     AND SUBSTR(II.CDFISCOPERIT, 1, 1) <> '3'
                                     AND FO.CDFORNECED(+)    = NF.CDFORNECED
                                     AND EF.CDFORNECED(+)    = FO.CDFORNECED
                                     AND EF.IDTPENDEFORN(+) = NVL(FO.IDENDEMISFOR,'P')
                                     AND EF.CDPAIS          = NVL(P_CDPAIS,EF.CDPAIS)
                                     AND (INSTR(NVL(P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0)
                                     AND NF.CDMODDOCFISC    = MD.CDMODDOCFISC
                                     AND NVL(MD.CDTPREGFISC, '50')  = '50'
                                     AND (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                          NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                   GROUP BY NF.CDFILIAL, NF.NRLANCTONF, NF.DTEMISSAO,
                                            NF.CDMODDOCFISC, NVL(NF.CDSERIE, NF.CDSERIEENTR),
                                            NF.NRNOTAFISC, IT.NRSEQITPROD,
                                            IT.CDPRODUTO, CDSITUTRIBPR, IT.QTITEMPROD, IT.VRTOTAITEM,
                                            IT.VRDESCITEM, NF.NRINSJURNF, DECODE(CDFISCALIT, '1', II.VRBASECALCIT, 0), IT.CDPRODNCMTRANS) IT
                             WHERE IT.CDPRODUTO = PR.CDPRODUTO
                             ORDER BY IT.CDFILIAL, IT.NRLANCTONF, IT.NRSEQITPROD) LOOP
         V_CONTREG54A := NVL(V_CONTREG54A,0)+1;
         IF ((C_REGISTRO54A.CDFILIAL||C_REGISTRO54A.NRLANCTONF) <> (V_CDFILIAL||V_NRLANCTONF)) THEN
            V_CDFILIAL   := C_REGISTRO54A.CDFILIAL;
            V_NRLANCTONF := C_REGISTRO54A.NRLANCTONF;
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
         END IF;
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('05'||LPAD(RTRIM(TO_CHAR(V_CONTREG54A)), 8, '0'), C_REGISTRO54A.DSINICIO||V_SEQUENCIAL||C_REGISTRO54A.DSARQMAG, P_NRSEQARQMAG);
         V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER(RTRIM(V_SEQUENCIAL))+1)), 3,'0');
         V_CONTREG := V_CONTREG + 1;
         V_CONTGERAL := V_CONTGERAL + 1;
         SELECT MAX(CDARVPROD)
         INTO V_CDARVPROD
         FROM TMP_REGISTRO_PRODUTO
         WHERE CDARVPROD = C_REGISTRO54A.CDARVPROD;
         IF V_CDARVPROD IS NULL THEN
            INSERT INTO TMP_REGISTRO_PRODUTO(CDTIPOREG, CDARVPROD, DTINICIAL, DTFINAL, CDCLASFISC, NMPRODUTO,
                                             SGUNIDADE, CDSITUTRIBPR, VRALIQIPI, VRALIQICMS, VRPERREDBCIT, VRBASESUBST)
            VALUES('75', C_REGISTRO54A.CDARVPROD, P_DTINICIAL, P_DTFINAL, C_REGISTRO54A.CDCLASFISC, C_REGISTRO54A.NMPRODUTO,
                   C_REGISTRO54A.SGUNIDADE, C_REGISTRO54A.CDSITUTRIBPR, C_REGISTRO54A.VRALIQIPI, C_REGISTRO54A.VRALIQICMS,
                   C_REGISTRO54A.VRPERREDBCIT, 0);
         END IF;
      END LOOP;
      IF V_CONTREG > 0 THEN
         V_STTOTAL := V_STTOTAL||'54'||LPAD(RTRIM(TO_CHAR(V_CONTREG)),8,'0');
      END IF;
   END IF;
   /*  GERAO DO REGISTRO 55 */
   V_CONTREG := 0;
   IF SUBSTR(P_REGISTRO,5,1) = 'S' THEN
      FOR C_REGISTRO55 IN (SELECT SUBSTR('55' ||
                                         REPLACE(REPLACE(REPLACE(I.NRINSJURIEST,'.',''),'-',''),'/','') ||
                                         RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(DECODE(SUBSTR(UPPER(M.CDINSCESTA),1,5),'ISENT','ISENTO',M.CDINSCESTA), ' ', ''),'.',''),',',''),'-',''),'/',''),'ISENTO'),14,' ')||
                                         TO_CHAR(P.DTORIGVENPAG,'yyyymmdd')||
                                         RPAD(I.SGESTADO,2,' ')||
                                         RPAD(EF.SGESTADO,2,' ')||
                                         NVL(B.CDBANCBOLP, '   ')||
                                         NVL(SUBSTR(CDAGENBOLP,2,5), '    ') ||
                                         NVL(M.NRAUTBANDOC, '                    ')||
                                         LTRIM(REPLACE(TO_CHAR(ROUND(ABS(P.VRATUAPAG),2),'00000000000.00'),'.',''))||
                                         TO_CHAR(P.DTATUAVENPAG,'yyyymmdd')||
                                         TO_CHAR(P.DTATUAVENPAG,'mmyyyy')||
                                         RPAD(SUBSTR(M.NRCONPROMER,1,22),30,' ') ,1,126) AS DSARQUMAG
                           FROM MAPAAPURAC M, CONTAPAGAR P,  NOTAFISCAL N ,ENDEFORN EF,
                                BOLETPAGAR B, INSCRESTAD I
                           WHERE M.CDEMPRESA    = P_CDEMPRESA      AND
                                 M.CDIMPOSTO    = P_CDIMPOSTO      AND
                                 M.CDINSCESTA   = P_CDINSCESTA     AND
                                 M.DTINIPERIODO = P_DTINICIAL      AND
                                 M.DTFIMPERIODO = P_DTFINAL        AND
                                 M.CDFILIAL     = P.CDFILIAL       AND
                                 M.NRLANCTONF   = P.NRLANCTONF     AND
                                 M.CDEMPRESA    = I.CDEMPRESA      AND
                                 M.CDINSCESTA   = I.CDINSCESTA     AND
                                 N.CDFILIAL     = P.CDFILIAL       AND
                                 N.NRLANCTONF   = P.NRLANCTONF     AND
                                 N.CDFORNECED   = EF.CDFORNECED(+) AND
                                 P.CDFILIBPAG   = B.CDFILIAL       AND
                                 P.NRLANBOLPAG  = B.NRLANBOLPAG    AND
                                 NVL(EF.IDTPENDEFORN,'P') = 'P'    AND
                                 (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                  NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                  NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                  NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                  NVL(IDSISTEMA, 'DFS') <> 'FIS')) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('08'||LPAD(RTRIM('00'), 8, '0'), C_REGISTRO55.DSARQUMAG, P_NRSEQARQMAG);
         V_CONTREG := V_CONTREG + 1;
         V_CONTGERAL := V_CONTGERAL + 1;
      END LOOP;
      IF V_CONTREG > 0 THEN
         V_STTOTAL := V_STTOTAL||'55'||LPAD(RTRIM(TO_CHAR(V_CONTREG)),8,'0');
      END IF;
   END IF;
   /* GERAO DO REGISTRO 60 */
   V_CONTREG  := 0;
   V_CONTADOR := 0;
   IF SUBSTR(P_REGISTRO,6,1) = 'S' THEN
      FOR C_REGISTRO60M IN (SELECT SUBSTR(
                               '60'||
                               'M'||
                               TO_CHAR(DTREDUCAOZ, 'yyyymmdd')||
                               RPAD(NRECFREDZ, 20, ' ')||
                               RPAD(CDCAIXA, 3, ' ')||
                               '2D'||
                               LPAD(NVL(LTRIM(DECODE(LENGTH(NRPRIMCFREDZ), 10, SUBSTR(NRPRIMCFREDZ, 5, 6), LPAD(NRPRIMCFREDZ, 6, '0'))),'0'), 6, '0')||
                               LPAD(NVL(LTRIM(DECODE(LENGTH(NRULTCFREDZ), 10, SUBSTR(NRULTCFREDZ, 5, 6), LPAD(NRULTCFREDZ, 6, '0'))),'0'), 6, '0')||
                               LPAD(NVL(LTRIM(LPAD(TO_CHAR(TO_NUMBER(NRREDREDZ)), 6, '0')),'0'), 6, '0')||
                               LPAD(NVL(LTRIM(DECODE(LENGTH(NRREINIREDZ), 10, SUBSTR(NRREINIREDZ, 8, 3), LPAD(NRREINIREDZ, 3, '0'))),'0'), 3, '0')||
                               LTRIM(REPLACE(TO_CHAR(ABS(NVL(RZ.VRVENBRUREDZ,0)),'00000000000000.00'),'.',''))||
                               LTRIM(REPLACE(TO_CHAR(ABS(NVL(VRGTREDZ,0)),'00000000000000.00'),'.',''))||
                               RPAD(' ', 37, ' '), 1 , 126) AS DSARQUMAG, RZ.DTREDUCAOZ
                            FROM
                               REDUCAOZ RZ ,FILIAL FI
                            WHERE (RZ.DTREDUCAOZ BETWEEN P_DTINICIAL AND P_DTFINAL) AND
                                  (RZ.CDFILIAL    = FI.CDFILIAL)      AND
                                  (FI.CDEMPRESA   = P_CDEMPRESA)     AND
                                  (FI.CDINSCESTA  = P_CDINSCESTA)
                            ORDER BY RZ.DTREDUCAOZ) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('09'||LPAD(RTRIM(V_CONTADOR), 8, '0'), C_REGISTRO60M.DSARQUMAG, P_NRSEQARQMAG);
         V_CONTADOR  := NVL(V_CONTADOR,0)+1;
         V_CONTREG   := V_CONTREG + 1;
         V_CONTGERAL := V_CONTGERAL + 1;
      END LOOP;
   END IF;
   IF SUBSTR(P_REGISTRO,7,1) = 'S' THEN
      FOR C_REGISTRO60A IN (SELECT SUBSTR(
                               '60'||
                               'A'||
                               TO_CHAR(DTREDUCAOZ, 'yyyymmdd')||
                               RPAD(NRECFREDZ, 20, ' ')||
                               RPAD(LTRIM(SITUTRIB), 4, ' ')||
                               LTRIM(REPLACE(TO_CHAR(VRACUMULADO,'0000000000.00'),'.',''))||
                               RPAD(' ', 79, ' '),1,126) AS DSARQMAG
                            FROM
                               (SELECT NRECFREDZ, DTREDUCAOZ,
                                       TO_CHAR(DECODE(VRALIQIMPRZ,0.00, 0, (VRALIQIMPRZ*100)),'0000') AS SITUTRIB,
                                       SUM(VRBCALCIMPRZ) VRACUMULADO
                                FROM IMPOSTOREDZ IZ, FILIAL FI, IMPOSTO I
                                WHERE (DTREDUCAOZ BETWEEN P_DTINICIAL AND P_DTFINAL) AND
                                      (IZ.CDFILIAL   = FI.CDFILIAL)   AND
                                      (FI.CDEMPRESA  = P_CDEMPRESA)   AND
                                      (FI.CDINSCESTA = P_CDINSCESTA)  AND
                                      (IZ.CDIMPOSTO  = I.CDIMPOSTO)   AND
                                      (I.IDTPIMPOSFIS = 'T')
                                GROUP BY NRECFREDZ, DTREDUCAOZ, VRALIQIMPRZ
                                UNION ALL
                                SELECT NRECFREDZ, DTREDUCAOZ, 'F' AS SITUTRIB, SUM(VRSTRIBREDZ) VRACUMULADO
                                FROM REDUCAOZ RZ, FILIAL FI
                                WHERE (DTREDUCAOZ BETWEEN P_DTINICIAL AND P_DTFINAL) AND
                                      (RZ.CDFILIAL   = FI.CDFILIAL)   AND
                                      (FI.CDEMPRESA  = P_CDEMPRESA)   AND
                                      (FI.CDINSCESTA = P_CDINSCESTA)  AND
                                      (VRSTRIBREDZ > 0)
                                GROUP BY NRECFREDZ, DTREDUCAOZ
                                UNION ALL
                                SELECT NRECFREDZ, DTREDUCAOZ, 'I' AS SITUTRIB, SUM(VRISENCREDZ) AS VRACUMULADO
                                FROM REDUCAOZ RZ, FILIAL FI
                                WHERE (DTREDUCAOZ BETWEEN P_DTINICIAL AND P_DTFINAL) AND
                                      (RZ.CDFILIAL   = FI.CDFILIAL)   AND
                                      (FI.CDEMPRESA  = P_CDEMPRESA)   AND
                                      (FI.CDINSCESTA = P_CDINSCESTA)  AND
                                      (VRISENCREDZ > 0)
                                GROUP BY NRECFREDZ, DTREDUCAOZ
                                UNION ALL
                                SELECT NRECFREDZ, DTREDUCAOZ, 'N' AS SITUTRIB, SUM(VRNINCIDREDZ) AS VRACUMULADO
                                FROM REDUCAOZ RZ, FILIAL FI
                                WHERE (DTREDUCAOZ BETWEEN P_DTINICIAL AND P_DTFINAL) AND
                                      (RZ.CDFILIAL   = FI.CDFILIAL)    AND
                                      (FI.CDEMPRESA  =  P_CDEMPRESA)   AND
                                      (FI.CDINSCESTA =  P_CDINSCESTA)  AND
                                      (VRNINCIDREDZ > 0 )
                                GROUP BY NRECFREDZ, DTREDUCAOZ
                                UNION ALL
                                SELECT NRECFREDZ, DTREDUCAOZ, 'CANC' AS SITUTRIB, SUM(VRTOTCANREDZ) AS VRACUMULADO
                                FROM REDUCAOZ RZ, FILIAL FI
                                WHERE (DTREDUCAOZ BETWEEN  P_DTINICIAL AND  P_DTFINAL) AND
                                      (RZ.CDFILIAL   = FI.CDFILIAL) AND
                                      (FI.CDEMPRESA  =  P_CDEMPRESA) AND
                                      (FI.CDINSCESTA =  P_CDINSCESTA) AND
                                      (VRTOTCANREDZ > 0)
                                GROUP BY NRECFREDZ, DTREDUCAOZ
                                UNION ALL
                                SELECT NRECFREDZ, DTREDUCAOZ, 'DESC' AS SITUTRIB, SUM(VRTOTDESREDZ) AS VRACUMULADO
                                FROM REDUCAOZ RZ, FILIAL FI
                                WHERE (DTREDUCAOZ BETWEEN  P_DTINICIAL AND  P_DTFINAL) AND
                                      (RZ.CDFILIAL   = FI.CDFILIAL) AND
                                      (FI.CDEMPRESA  =  P_CDEMPRESA) AND
                                      (FI.CDINSCESTA =  P_CDINSCESTA) AND
                                      (VRTOTDESREDZ > 0)
                                GROUP BY NRECFREDZ, DTREDUCAOZ
                                UNION ALL
                                SELECT NRECFREDZ, DTREDUCAOZ, 'ISS' AS SITUTRIB, SUM(VRBCALCIMPRZ) VRACUMULADO
                                FROM IMPOSTOREDZ IZ, FILIAL FI, IMPOSTO I
                                WHERE (DTREDUCAOZ BETWEEN  P_DTINICIAL AND  P_DTFINAL) AND
                                      (IZ.CDFILIAL   = FI.CDFILIAL) AND
                                      (FI.CDEMPRESA  =  P_CDEMPRESA) AND
                                      (FI.CDINSCESTA =  P_CDINSCESTA) AND
                                      (IZ.CDIMPOSTO = I.CDIMPOSTO) AND
                                      (I.IDTPIMPOSFIS = 'I')
                                GROUP BY NRECFREDZ, DTREDUCAOZ) ) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('10'||LPAD(RTRIM('00'), 8, '0'), C_REGISTRO60A.DSARQMAG, P_NRSEQARQMAG);
         V_CONTREG := V_CONTREG + 1;
         V_CONTGERAL := V_CONTGERAL + 1;
      END LOOP;
   END IF;

   V_CONTADOR  := 0;
   IF SUBSTR(P_REGISTRO,8,1) = 'S' THEN
      FOR C_REGISTRO60R IN(SELECT SUBSTR(
                              '60'||
                              'R'||
                              TO_CHAR(A.DTENTRVENDA, 'mmyyyy')||
                              RPAD(A.CDARVPROD, 14, ' ')||
                              LTRIM(REPLACE(TO_CHAR(ABS(QTPRODVEND),'0000000000.000'),'.',''))||
                              LTRIM(REPLACE(TO_CHAR(ABS(VRUNIT),    '00000000000000.00'),'.',''))||
                              LTRIM(REPLACE(TO_CHAR(ABS(BASECALC),  '00000000000000.00'),'.',''))||
                              DECODE(A.IDTPIMPOSFIS, 'F', 'F   ', DECODE(A.IDTPIMPOSFIS, 'N', 'N   ',
                                                                  DECODE(A.IDTPIMPOSFIS, 'I', 'I   ',
                                                                  DECODE(A.VRPEALPRODIT,0.00, 'F   ',LTRIM(REPLACE(TO_CHAR(A.VRPEALPRODIT, '00.00'),'.', ''))))))||
                              RPAD(' ', 54, ' '), 1, 126) AS DSARQMAG,
                              A.CDARVPROD, A.NMPRODUTO, NVL(A.SGUNIDADE, ' ') AS SGUNIDADE, NVL(CDCLASFISC, ' ')AS CDCLASFISC
                           FROM
                              (SELECT I.IDTPIMPOSFIS, VD.DTENTRVENDA, PD.CDARVPROD, PD.NMPRODUTO, PD.SGUNIDADE,
                                      NVL(IT.CDCLASFISC,PD.CDCLASFISC) AS CDCLASFISC, SUM(IT.QTPRODVEND) AS QTPRODVEND,
                                      AI.VRPEALPRODIT, SUM(IT.VRUNITVEND+NVL(VRUNITVENDCL,0)) AS VRUNIT,
                                      SUM(IT.QTPRODVEND * ((IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))-NVL(IT.VRDESITVEND,0)+ NVL(IT.VRACRITVEND,0))) AS BASECALC
                               FROM (SELECT FI.CDFILIAL, FI.CDINSCESTA, FI.CDEMPRESA
                                     FROM FILIAL FI
                                     WHERE FI.CDEMPRESA    =  P_CDEMPRESA      AND
                                           FI.CDINSCESTA   =  P_CDINSCESTA     ) FI,
                                     PRODUTO PD, IMPOSTO I, ITVENDAIMPOS AI, ITEMVENDA IT, VENDA VD
                               WHERE VD.CDFILIAL     = FI.CDFILIAL       AND
                                     VD.IDSITUVENDA = 'O'                AND
                                     VD.DTENTRVENDA BETWEEN  P_DTINICIAL AND  P_DTFINAL AND
                                     VD.CDFILIAL     = IT.CDFILIAL       AND
                                     VD.CDCAIXA      = IT.CDCAIXA        AND
                                     VD.NRSEQVENDA   = IT.NRSEQVENDA     AND
                                     VD.IDVENDEBCONS <> 'S'              AND
                                     IT.CDPRODUTO    = PD.CDPRODUTO      AND
                                     IT.CDFILIAL     = AI.CDFILIAL       AND
                                     IT.CDCAIXA      = AI.CDCAIXA        AND
                                     IT.NRSEQVENDA   = AI.NRSEQVENDA     AND
                                     IT.NRSEQUITVEND = AI.NRSEQUITVEND   AND
                                     AI.CDIMPOSTO    = I.CDIMPOSTO       AND
                                     I.IDTPIMPOSFIS  IN('T', 'F', 'N', 'I')
                               GROUP BY
                                  I.IDTPIMPOSFIS, VD.DTENTRVENDA, PD.CDARVPROD, PD.NMPRODUTO, PD.SGUNIDADE, NVL(IT.CDCLASFISC,PD.CDCLASFISC), AI.VRPEALPRODIT ) A
                           ORDER BY TO_CHAR(A.DTENTRVENDA, 'mmyyyy'), A.CDARVPROD) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('13'||LPAD(RTRIM(V_CONTADOR), 8, '0'), C_REGISTRO60R.DSARQMAG, P_NRSEQARQMAG);
         V_CONTADOR  := NVL(V_CONTADOR,0)+1;
         V_CONTREG   := V_CONTREG + 1;
         V_CONTGERAL := V_CONTGERAL + 1;
         SELECT MAX(CDARVPROD)
         INTO V_CDARVPROD
         FROM TMP_REGISTRO_PRODUTO
         WHERE CDARVPROD = C_REGISTRO60R.CDARVPROD;
         IF V_CDARVPROD IS NULL THEN
            INSERT INTO TMP_REGISTRO_PRODUTO(CDTIPOREG, CDARVPROD, DTINICIAL, DTFINAL, CDCLASFISC, NMPRODUTO,
                                             SGUNIDADE, CDSITUTRIBPR, VRALIQIPI, VRALIQICMS, VRPERREDBCIT, VRBASESUBST)
            VALUES('75', C_REGISTRO60R.CDARVPROD, P_DTINICIAL, P_DTFINAL, C_REGISTRO60R.CDCLASFISC, C_REGISTRO60R.NMPRODUTO,
                   C_REGISTRO60R.SGUNIDADE, '040', 0.00, 0.00, 0.00, 0);
         END IF;
      END LOOP;
   END IF;
      IF V_CONTREG > 0 THEN
         V_STTOTAL := V_STTOTAL||'60'||LPAD(RTRIM(TO_CHAR(V_CONTREG)),8,'0');
      END IF;
   /* GERAO DO REGISTRO 61 */
   V_CONTREG  := 0;
   V_CONTADOR := 0;
   IF SUBSTR(P_REGISTRO,9,1) = 'S' THEN
      FOR C_REGISTRO61 IN(SELECT SUBSTR('61'||
                                        RPAD(' ', 14, ' ')||
                                        RPAD(' ', 14, ' ')||
                                        TO_CHAR(NF.DTEMISSAO, 'yyyymmdd')||
                                        RPAD('02', 2, ' ')||
                                        RPAD(DECODE(TRIM(NVL(NF.CDSERIE,' ')),'-',' ','0',' ',NVL(NF.CDSERIE,' ')),5,' ')||
                                        LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0')||
                                        LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0')||
                                        LTRIM(REPLACE(TO_CHAR(NF.VRCONTABILNF, '00000000000.00'),'.',''))||
                                        LTRIM(REPLACE(TO_CHAR(ABS(NF.VRBASECALCNF),'00000000000.00'),'.',''))||
                                        LTRIM(REPLACE(TO_CHAR(ABS(NF.VRIMPOSTONF),'0000000000.00'),'.',''))||
                                        LTRIM(REPLACE(TO_CHAR(ABS(NF.VRISENTRIB),'00000000000.00'),'.',''))||
                                        LTRIM(REPLACE(TO_CHAR(ABS(NF.VROUTRCRED),'00000000000.00'),'.',''))||
                                        LTRIM(REPLACE(TO_CHAR(ABS(NF.VRALIQNF),'00.00'),'.',''))||
                                        RPAD(' ', 1, ' '),1, 126) AS DSARQMAG, NF.DTEMISSAO
                          FROM
                             (/*SELECT I.NRLANCTONF, N.CDSERIE, N.DTEMISSAO, I.VRALIQNF, N.CDMODDOCFISC, N.VRNOTAFISC,
                                     SUM(I.VRCONTABILNF) AS VRCONTABILNF, N.NRNOTAFISC,
                                     SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                                     SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                     SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0))   AS VROUTRCRED,
                                     SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,DECODE(SUBSTR(I.CDSITUTRIBNF,2,2),'20',I.VRCONTABILNF-I.VRBASECALCNF,0)))   AS VRISENTRIB
                               FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, ITEMPRODUTO IP, ITEMVENDA IV, MOVICLIE MC, MODDOCFISC MD, IMPOSTO IM
                               WHERE M.CDEMPRESA       = P_CDEMPRESA                   AND
                                     M.CDINSCESTA      = P_CDINSCESTA                  AND
                                     M.DTINIPERIODO    = P_DTINICIAL                   AND
                                     M.DTFIMPERIODO    = P_DTFINAL                     AND
                                     M.CDIMPOSTO       = P_CDIMPOSTO                   AND
                                     I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                AND
                                     IM.CDIMPOSTONFE   = P_CDIMPOSTO                   AND
                                     IM.CDIMPOSTO      = I.CDIMPOSTO                   AND
                                     NVL(I.IDIMPOSTONF, '1') <> '3'                    AND
                                     N.CDFILIAL        = I.CDFILIAL                    AND
                                     N.NRLANCTONF      = I.NRLANCTONF                  AND
                                     N.IDSTATUS IN ('A','E')                           AND
                                     N.IDENTRSAIDOP    = 'S'                           AND
                                     NVL(SUBSTR(I.CDFISCOPERNF,1,1),' ') <> '7'        AND
                                     N.CDFILIAL        = IP.CDFILIAL                   AND
                                     N.NRLANCTONF      = IP.NRLANCTONF                 AND
                                     IP.CDFILIAL       = IV.CDFILIAL(+)                AND
                                     IP.CDCAIXA        = IV.CDCAIXA  (+)               AND
                                     IP.NRSEQVENDA     = IV.NRSEQVENDA (+)             AND
                                     IP.NRSEQUITVEND   = IV.NRSEQUITVEND(+)            AND
                                     IV.CDFILIAL       = MC.CDFILIAL (+)               AND
                                     IV.CDCAIXA        = MC.CDCAIXA   (+)              AND
                                     IV.NRSEQVENDA     = MC.NRSEQVENDA (+)             AND
                                     N.CDMODDOCFISC    = MD.CDMODDOCFISC               AND
                                     MD.CDTPREGFISC    = '61'                          AND
                                     (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                      NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                      NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                      NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                      NVL(IDSISTEMA, 'DFS') <> 'FIS')
                               GROUP BY I.NRLANCTONF, N.CDSERIE, N.DTEMISSAO, I.VRALIQNF, N.CDMODDOCFISC, N.VRNOTAFISC, N.NRNOTAFISC
                               UNION*/
                               SELECT NF.NRLANCTONF, NF.CDSERIE, NF.DTEMISSAO, I.VRALIQNF, NF.CDMODDOCFISC, NF.VRNOTAFISC,
                                      SUM(I.VRCONTABILNF) AS VRCONTABILNF, NF.NRNOTAFISC,
                                      SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                                      SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                      SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0))   AS VROUTRCRED,
                                      SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,DECODE(SUBSTR(I.CDSITUTRIBNF,2,2),'20',I.VRCONTABILNF-I.VRBASECALCNF,0))) AS VRISENTRIB
                               FROM MAPAAPURAC M, NOTAFISCAL NF, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM
                               WHERE M.CDEMPRESA       = P_CDEMPRESA                   AND
                                     M.CDINSCESTA      = P_CDINSCESTA                  AND
                                     M.DTINIPERIODO    = P_DTINICIAL                   AND
                                     M.DTFIMPERIODO    = P_DTFINAL                     AND
                                     M.CDIMPOSTO       = P_CDIMPOSTO                   AND
                                     I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                AND
                                     IM.CDIMPOSTONFE   = P_CDIMPOSTO                   AND
                                     IM.CDIMPOSTO      = I.CDIMPOSTO                   AND
                                     NVL(I.IDIMPOSTONF, '1') <> '3'                    AND
                                     NF.IDENTRSAIDOP     = 'S'                         AND
                                     NF.IDSTATUS IN ('A','E')                          AND
                                     NVL(SUBSTR(I.CDFISCOPERNF,1,1),' ') <> '7'        AND
                                     NF.CDFILIAL        = I.CDFILIAL                   AND
                                     NF.NRLANCTONF      = I.NRLANCTONF                 AND
                                     NF.CDMODDOCFISC    = MD.CDMODDOCFISC              AND
                                     MD.CDTPREGFISC      = '61'                        AND
                                     (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                      NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                      NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                      NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                      NVL(IDSISTEMA, 'DFS') <> 'FIS')
                               GROUP BY NF.NRLANCTONF, NF.CDSERIE, NF.DTEMISSAO, I.VRALIQNF, NF.CDMODDOCFISC, NF.VRNOTAFISC,
                                        NF.NRNOTAFISC) NF
                          ORDER BY NF.DTEMISSAO) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('14'||LPAD(RTRIM(V_CONTADOR), 8, '0'), C_REGISTRO61.DSARQMAG, P_NRSEQARQMAG);
         V_CONTADOR  := NVL(V_CONTADOR,0)+1;
         V_CONTREG   := V_CONTREG + 1;
         V_CONTGERAL := V_CONTGERAL + 1;
      END LOOP;
      IF V_CONTREG > 0 THEN
         V_STTOTAL := V_STTOTAL||'61'||LPAD(RTRIM(TO_CHAR(V_CONTREG)),8,'0');
      END IF;
   END IF;
   /* GERAO DO REGISTRO 70 */
   V_CONTADOR := 0;
   V_CONTREG := 0;
   IF SUBSTR(P_REGISTRO,10,1) = 'S' THEN
      FOR C_REGISTRO70 IN (SELECT SUBSTR('70'          ||
                                         NRINSJURNF    ||
                                         NRINSESTFORN  ||
                                         DTENTRSAID    ||
                                         SGESTADO      ||
                                         CDMODDOCFISC  ||
                                         nvl(CDSERIEENTR, '   ')   ||
                                         NRNOTAFISC    ||
                                         CDFISCOPERNF  ||
                                         VRNOTAFISC    ||
                                         VRBASECALCNF  ||
                                         VRIMPOSTONF   ||
                                         VRISENTRIB    ||
                                         VROUTRCRED    ||
                                         IDPGTOFRETE   ||
                                         IDSTATUS,1 , 126) AS DSARQMAG, DTENTRSAID, CDSERIEENTR
                           FROM(SELECT '70',
                                       RPAD(NVL(NF.NRINSJURNF,'00000000000000'),14,' ') AS NRINSJURNF,
                                       RPAD(NVL(REPLACE(REPLACE(REPLACE(FO.NRINSESTFORN,'.',''),',',''),'-',''),'ISENTO'),14,' ') AS NRINSESTFORN,
                                       TO_CHAR(NF.DTENTRSAID,'yyyymmdd') AS DTENTRSAID,
                                       RPAD(NVL(EF.SGESTADO,' '),2,' ') AS SGESTADO,
                                       RPAD(NVL(NF.CDMODDOCFISC,' '), 2, ' ') AS CDMODDOCFISC,
                                       RPAD(REPLACE(DECODE(NVL(NF.CDSERIEENTR,' '),'0',' '),'-',' '),3,' ') AS CDSERIEENTR,
                                       LPAD(SUBSTR(NF.NRNOTAFISC,LENGTH(NF.NRNOTAFISC)-5,6),6,'0') AS NRNOTAFISC,
                                       RPAD(NVL(NF.CDFISCOPERNF,'0'),4,' ') AS CDFISCOPERNF,
                                       LTRIM(REPLACE(TO_CHAR(NF.VRNOTAFISC, '00000000000.00'),'.',''))   AS VRNOTAFISC,
                                       LTRIM(REPLACE(TO_CHAR(NF.VRBASECALCNF,'000000000000.00'),'.','')) AS VRBASECALCNF,
                                       LTRIM(REPLACE(TO_CHAR(NF.VRIMPOSTONF, '000000000000.00'),'.','')) AS VRIMPOSTONF,
                                       LTRIM(REPLACE(TO_CHAR(NF.VRISENTRIB,  '000000000000.00'),'.','')) AS VRISENTRIB,
                                       LTRIM(REPLACE(TO_CHAR(NF.VROUTRCRED,  '000000000000.00'),'.','')) AS VROUTRCRED,
                                       RPAD(DECODE(NVL(NF.IDPGTOFRETE, '0'), '0', '1','1','2','2','2','9','0'), 1, ' ') AS IDPGTOFRETE,
                                       DECODE(NF.IDSTATUS, 'C', 'S', 'N') AS IDSTATUS
                                FROM FORNECEDOR FO, ENDEFORN EF,
                                   (SELECT N.CDFILIAL, N.NRLANCTONF, N.NRINSJURNF, N.CDFORNECED, N.DTENTRSAID, nvl(N.CDSERIEENTR,' ') as CDSERIEENTR,
                                           N.NRNOTAFISC, N.VRNOTAFISC, N.IDSTATUS, N.IDPGTOFRETE, I.CDFISCOPERNF, N.CDMODDOCFISC,
                                           SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                                           SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0))  AS VRIMPOSTONF,
                                           SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,0)) AS VRISENTRIB,
                                           SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)) AS VROUTRCRED
                                     FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, MODDOCFISC MD, IMPOSTO IM
                                     WHERE (M.CDEMPRESA       = P_CDEMPRESA)     AND
                                           (M.CDINSCESTA      = P_CDINSCESTA)    AND
                                           (M.DTINIPERIODO    = P_DTINICIAL)     AND
                                           (M.DTFIMPERIODO    = P_DTFINAL)       AND
                                           (M.CDIMPOSTO       = P_CDIMPOSTO)     AND
                                           (I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU)  AND
                                           (IM.CDIMPOSTONFE   = P_CDIMPOSTO)     AND
                                           (IM.CDIMPOSTO      = I.CDIMPOSTO)     AND
                                           (NVL(I.IDIMPOSTONF, '1') <> '3')      AND
                                           (N.CDFILIAL   = I.CDFILIAL)           AND
                                           (N.NRLANCTONF = I.NRLANCTONF)         AND
                                           (N.IDENTRSAIDOP = 'E' )               AND
                                           (N.IDSTATUS IN ('A', 'E'))            AND
                                           (N.CDMODDOCFISC    = MD.CDMODDOCFISC) AND
                                           (MD.CDTPREGFISC    = '70')            AND
                                           (NVL(IDSISTEMA, 'DFS') <> 'REC' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'PAG' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'CMP' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'SUP' AND
                                            NVL(IDSISTEMA, 'DFS') <> 'FIS')
                                     GROUP BY N.CDFILIAL, N.NRLANCTONF, N.NRINSJURNF, N.CDFORNECED, N.DTENTRSAID, nvl(N.CDSERIEENTR,' '),
                                           N.NRNOTAFISC, N.VRNOTAFISC, N.IDSTATUS, N.IDPGTOFRETE,I.CDFISCOPERNF, N.CDMODDOCFISC) NF
                                WHERE (FO.CDFORNECED      = NF.CDFORNECED  )              AND
                                      (EF.CDFORNECED(+)   = FO.CDFORNECED  )              AND
                                      (EF.IDTPENDEFORN(+) = NVL(FO.IDENDEMISFOR,'P'))     AND
                                      (EF.CDPAIS          = NVL( P_CDPAIS,EF.CDPAIS))     AND
                                      (INSTR(NVL( P_SGESTADO, EF.SGESTADO), EF.SGESTADO) > 0) )NF
                           ORDER BY DTENTRSAID) LOOP
         --raise_application_error(-20501, to_char(nvl(C_REGISTRO70.CDSERIEENTR,'0000')), true);
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('15'||LPAD(RTRIM(V_CONTADOR), 8, '0'), C_REGISTRO70.DSARQMAG, P_NRSEQARQMAG);
         V_CONTADOR  := NVL(V_CONTADOR,0)+1;
         V_CONTREG   := V_CONTREG + 1;
         V_CONTGERAL := V_CONTGERAL + 1;
      END LOOP;
      IF V_CONTREG > 0 THEN
         V_STTOTAL := V_STTOTAL||'70'||LPAD(RTRIM(TO_CHAR(V_CONTREG)),8,'0');
      END IF;
   END IF;
   /* GERAO DO REGISTRO 74 */
   V_CONTREG  := 0;
   V_CONTADOR := 0;
   IF SUBSTR(P_REGISTRO,11,1) = 'S' THEN
      FOR C_REGISTRO74 IN (SELECT SUBSTR(
                                  '74'||
                                  TO_CHAR(DTINVEFISCAL,'yyyymmdd')||
                                  RPAD(CDARVPROD,14, ' ')||
                                  LTRIM(REPLACE(TO_CHAR(QTESTINVFISC,'00000000000.00'),'.',''))||
                                  LTRIM(REPLACE(TO_CHAR(VRTOTINVFISC,'00000000000.00'),'.',''))||
                                  '1'||
                                  RPAD('0', 14, '0')||
                                  RPAD(' ', 14, ' ')||
                                  RPAD(' ',  2, ' ')||
                                  RPAD(' ', 45, ' '), 1, 126) AS DSARQMAG,
                                  CDARVPROD, NVL(CDCLASFISC, ' ') AS CDCLASFISC, NMPRODUTO, SGUNIDADE , DTINVEFISCAL
                            FROM (SELECT I.VRTOTINVFISC,I.QTESTINVFISC, I.DTINVEFISCAL, P.CDARVPROD,
                                         NVL(I.CDCLASFISC,P.CDCLASFISC) AS CDCLASFISC, P.NMPRODUTO, P.SGUNIDADE
                                    FROM INVENTFISC I, PRODUTO P
                                   WHERE I.CDEMPRESA    = P_CDEMPRESA
                                     AND I.CDINSCESTA   = P_CDINSCESTA
                                     AND I.CDPRODUTO    = P.CDPRODUTO
                                     AND I.QTESTINVFISC <> 0
                                     AND I.VRTOTINVFISC <> 0
                                     AND I.DTINVEFISCAL = (SELECT MAX(DTINVEFISCAL)
                                                              FROM INVENTFISC V  , PRODUTO PR
                                                            WHERE V.DTINVEFISCAL <= P_DTPOSICAO
                                                              AND V.CDEMPRESA = P_CDEMPRESA
                                                              AND V.CDINSCESTA   = P_CDINSCESTA
                                                              AND V.CDPRODUTO    = PR.CDPRODUTO
                                                              AND V.QTESTINVFISC <> 0))) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('16'||LPAD(RTRIM(V_CONTADOR), 8, '0'), C_REGISTRO74.DSARQMAG, P_NRSEQARQMAG);
         V_CONTADOR  := NVL(V_CONTADOR,0)+1;
         V_CONTREG   := V_CONTREG + 1;
         V_CONTGERAL := V_CONTGERAL + 1;
         SELECT MAX(CDARVPROD)
         INTO V_CDARVPROD
         FROM TMP_REGISTRO_PRODUTO
         WHERE CDARVPROD = C_REGISTRO74.CDARVPROD;
         IF V_CDARVPROD IS NULL THEN
            INSERT INTO TMP_REGISTRO_PRODUTO(CDTIPOREG, CDARVPROD, DTINICIAL, DTFINAL, CDCLASFISC, NMPRODUTO,
                                             SGUNIDADE, CDSITUTRIBPR, VRALIQIPI, VRALIQICMS, VRPERREDBCIT, VRBASESUBST)
            VALUES('75', C_REGISTRO74.CDARVPROD, P_DTINICIAL, P_DTFINAL, C_REGISTRO74.CDCLASFISC, C_REGISTRO74.NMPRODUTO,
                   C_REGISTRO74.SGUNIDADE, '040', 0.00, 0.00, 0.00, 0);
         END IF;
      END LOOP;
      IF V_CONTREG > 0 THEN
         V_STTOTAL := V_STTOTAL||'74'||LPAD(RTRIM(TO_CHAR(V_CONTREG)),8,'0');
      END IF;
   END IF;
   /* GERAO DO REGISTRO 75 */
   V_CONTREG := 0;
   IF SUBSTR(P_REGISTRO,12,1) = 'S' THEN
      IF P_VERSAO = '3' THEN
         FOR C_REGISTRO75 IN (SELECT SUBSTR(CDTIPOREG ||
                                            TO_CHAR(DTINICIAL, 'YYYYMMDD')||
                                            TO_CHAR(DTFINAL  , 'YYYYMMDD')||
                                            RPAD(CDARVPROD, 14, ' ')      ||
                                            RPAD(CDCLASFISC, 8, ' ')  ||
                                            RPAD(TRIM(NMPRODUTO), 53, ' ')      ||
                                            RPAD(SGUNIDADE, 6, ' ')       ||
                                            LTRIM(REPLACE(TO_CHAR(VRALIQIPI, '000.00'),'.',''))||
                                            LTRIM(REPLACE(TO_CHAR(VRALIQICMS, '00.00'),'.',''))||
                                            LTRIM(REPLACE(TO_CHAR(VRPERREDBCIT, '000.00'),'.',''))||
                                            '0000000000000', 1, 126) AS DSARQMAG
                              FROM TMP_REGISTRO_PRODUTO
                              ORDER BY CDARVPROD) LOOP
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              ('17'||LPAD(RTRIM('00'), 8, '0'), C_REGISTRO75.DSARQMAG, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
            V_CONTGERAL := V_CONTGERAL + 1;
         END LOOP;
      ELSE
         FOR C_REGISTRO75 IN (SELECT SUBSTR(CDTIPOREG ||
                                            TO_CHAR(DTINICIAL, 'YYYYMMDD')||
                                            TO_CHAR(DTFINAL  , 'YYYYMMDD')||
                                            RPAD(CDARVPROD, 14, ' ') ||
                                            RPAD(CDCLASFISC, 8, ' ')  ||
                                            RPAD(TRIM(NMPRODUTO), 53, ' ') ||
                                            RPAD(SGUNIDADE, 6, ' ')  ||
                                            RPAD(CDSITUTRIBPR,3, ' ') ||
                                            LTRIM(REPLACE(TO_CHAR(VRALIQIPI, '00.00'),'.',''))||
                                            LTRIM(REPLACE(TO_CHAR(VRALIQICMS, '00.00'),'.',''))||
                                            LTRIM(REPLACE(TO_CHAR(VRPERREDBCIT, '00.00'),'.',''))||
                                            '0000000000000', 1, 126) AS DSARQMAG
                              FROM TMP_REGISTRO_PRODUTO
                              ORDER BY CDARVPROD) LOOP
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              ('18'||LPAD(RTRIM('00'), 8, '0'), C_REGISTRO75.DSARQMAG, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
            V_CONTGERAL := V_CONTGERAL + 1;
         END LOOP;
      END IF;
      IF V_CONTREG > 0 THEN
         V_STTOTAL := V_STTOTAL||'75'||LPAD(RTRIM(TO_CHAR(V_CONTREG)),8,'0');
      END IF;
   END IF;
   IF V_CONTGERAL > 0 THEN
      V_TOTALGERAL := RTRIM(LPAD(RTRIM(TO_CHAR(V_CONTGERAL + 1)),8,'0'));
   END IF;
   /* GERAO DO REGISTRO 90 */
   FOR C_REGISTRO90 IN (SELECT SUBSTR(RPAD('90'||
                               RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(NRINSJURIEST,'.',''),',',''),'/',''),'-',''),'00000000000000'),14,' ')||
                               RPAD(NVL(REPLACE(REPLACE(REPLACE(DECODE(SUBSTR(UPPER(P_CDINSCESTA),1,5),'ISENT','ISENTO',P_CDINSCESTA),'.',''),',',''),'-',''),'ISENTO'),14,' ')||
                               V_STTOTAL ||
                               '99'||
                               V_TOTALGERAL, 125, ' ') ||
                               '1' ,1, 126) AS DSARQMAG
                            FROM  INSCRESTAD
                            WHERE CDEMPRESA  = P_CDEMPRESA AND
                                  CDINSCESTA = P_CDINSCESTA) LOOP
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('19'||LPAD(RTRIM('00'), 8, '0'), C_REGISTRO90.DSARQMAG, P_NRSEQARQMAG);
   END LOOP;
   DELETE FROM TMP_REGISTRO_PRODUTO;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_VALIDAPR','5.65.000'); END;
/

